VERSION 2.00
Begin Form Form1 
   Caption         =   "Skipping Deleted Records"
   ClientHeight    =   3210
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   9345
   Height          =   3615
   Left            =   -15
   LinkTopic       =   "Form1"
   ScaleHeight     =   3210
   ScaleWidth      =   9345
   Top             =   90
   Width           =   9465
   Begin CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   250
      Left            =   7200
      TabIndex        =   16
      Top             =   2640
      Width           =   1095
   End
   Begin TextBox txtID 
      DataField       =   "Employee ID"
      DataSource      =   "Data1"
      Enabled         =   0   'False
      Height          =   285
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   1335
   End
   Begin CommandButton cmdDelete 
      Caption         =   "Delete"
      Height          =   250
      Left            =   4800
      TabIndex        =   12
      Top             =   1080
      Width           =   1095
   End
   Begin CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   250
      Left            =   4800
      TabIndex        =   11
      Top             =   2640
      Width           =   1095
   End
   Begin CommandButton cmdSave 
      Caption         =   "Save"
      Height          =   250
      Left            =   4800
      TabIndex        =   10
      Top             =   2160
      Width           =   1095
   End
   Begin CommandButton cmdAdd 
      Caption         =   "Add"
      Height          =   250
      Left            =   4800
      TabIndex        =   9
      Top             =   1680
      Width           =   1095
   End
   Begin CommandButton cmdUpdate 
      Caption         =   "Update"
      Enabled         =   0   'False
      Height          =   250
      Left            =   4800
      TabIndex        =   8
      Top             =   600
      Width           =   1095
   End
   Begin CommandButton cmdFind 
      Caption         =   "Find"
      Height          =   250
      Left            =   4800
      TabIndex        =   7
      Top             =   120
      Width           =   1095
   End
   Begin CommandButton cmdLast 
      Caption         =   "Last"
      Height          =   250
      Left            =   7200
      TabIndex        =   6
      Top             =   1920
      Width           =   1100
   End
   Begin CommandButton cmdFirst 
      Caption         =   "First"
      Height          =   250
      Left            =   7200
      TabIndex        =   5
      Top             =   1320
      Width           =   1100
   End
   Begin CommandButton cmdPrior 
      Caption         =   "Prior"
      Height          =   250
      Left            =   7200
      TabIndex        =   4
      Top             =   720
      Width           =   1100
   End
   Begin CommandButton cmdNext 
      Caption         =   "Next"
      Height          =   250
      Left            =   7200
      TabIndex        =   3
      Top             =   120
      Width           =   1100
   End
   Begin TextBox txtFirstName 
      DataField       =   "First Name"
      DataSource      =   "Data1"
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   1920
      Width           =   3135
   End
   Begin TextBox txtLastName 
      DataField       =   "Last Name"
      DataSource      =   "Data1"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   1080
      Width           =   3135
   End
   Begin Data Data1 
      Caption         =   "Data1"
      Connect         =   ""
      DatabaseName    =   "C:\VBDEMOS\NWIND.MDB"
      Exclusive       =   0   'False
      Height          =   270
      Left            =   240
      Options         =   0
      ReadOnly        =   0   'False
      RecordSource    =   "Employees"
      Top             =   2640
      Width           =   3135
   End
   Begin Label lblID 
      Caption         =   "ID Number"
      Height          =   255
      Left            =   240
      TabIndex        =   15
      Top             =   120
      Width           =   1095
   End
   Begin Label lblFirstName 
      Caption         =   "First Name"
      Height          =   255
      Left            =   240
      TabIndex        =   14
      Top             =   1680
      Width           =   1335
   End
   Begin Label lblLastName 
      Caption         =   "Last Name"
      Height          =   255
      Left            =   240
      TabIndex        =   13
      Top             =   840
      Width           =   975
   End
End
Option Explicit

Const SIZE = 11


Dim sQuote As String
Dim src As String
Dim criteria As String
Dim currentrecord As String

Const ERROR_MSG = "You have entered an Employee ID that already exists. Modify Employee ID before proceeding."

Const KEY_DELETE = &H2E

Sub cmdAdd_Click ()

    currentrecord = data1.RecordSet.Bookmark

    data1.RecordSet.AddNew
    
    'Show Save and Cancel - Disable Delete
    cmdSave.Visible = True
    cmdCancel.Visible = True
    cmdDelete.Enabled = False
    
    txtID.Enabled = True
    txtID.SetFocus
End Sub

Sub cmdCancel_Click ()
    
    'Restore position to where you were
    'when you started Adding records
     data1.RecordSet.Bookmark = currentrecord

    'Reset buttons to show leaving Add mode
    ReSetButtons
End Sub

Sub cmdDelete_Click ()
    On Error Resume Next

    data1.RecordSet.Delete
    data1.RecordSet.MoveNext
    
    'If the last record was just deleted, move to the
    'new last record
    If data1.RecordSet.EOF Then
        data1.RecordSet.MoveLast
    End If
End Sub

Sub cmdEnd_Click ()
    Unload form1
End Sub

Sub cmdFind_Click ()
    sQuote = Chr$(34)

    'If Save is visible - you were in the middle of adding
    'Hide Save/Cancel to show ADD was cancelled.
    cmdSave.Visible = False
    cmdCancel.Visible = False

    'Save the current position.
    currentrecord = data1.RecordSet.Bookmark

    src = InputBox$("Enter last name of employee to find", "Find Box")
    If src = "" Then Exit Sub
    
    criteria = "[Last Name] = " & sQuote & src & sQuote
    data1.RecordSet.FindFirst criteria
    
    If data1.RecordSet.NoMatch Then
        MsgBox "No Record Found!", , "What were you thinking?"
        data1.RecordSet.Bookmark = currentrecord
    Else
        cmdNext.Enabled = True
        cmdPrior.Enabled = True
    End If
End Sub

Sub cmdFirst_Click ()
    data1.RecordSet.MoveFirst
    cmdNext.Enabled = True
    cmdPrior.Enabled = False
End Sub

Sub cmdLast_Click ()
    data1.RecordSet.MoveLast
    cmdPrior.Enabled = True
    cmdNext.Enabled = False
End Sub

Sub cmdNext_Click ()

    On Error GoTo NextError
    data1.RecordSet.MoveNext
    cmdPrior.Enabled = True
    
    If data1.RecordSet.EOF Then
        On Error GoTo LastError
        data1.RecordSet.MoveLast
        cmdNext.Enabled = False
    End If
    Exit Sub

NextError:
    If Err = 3167 Then
        Resume  'You got deleted on MoveNext - reissue MoveNext to skip
    Else
        MsgBox Str$(Err) & Error$
        Resume Next
    End If

LastError:
    On Error GoTo PreviousError
    If Err = 3167 Then  'You got error on MoveLast. Last Record must be deleted
        data1.RecordSet.MovePrevious 'If you get deleted error here
        If data1.RecordSet.BOF Then  'go to Previous error
           MsgBox "THERE ARE NO RECORDS"
        End If
        Resume Next
    Else
        Resume Next
    End If

PreviousError:
    If Err = 3167 Then
        Resume  'Keep executing MovePrevious until you find good record or BOF
    Else
        MsgBox Str$(Err) & Error$
    End If

End Sub

Sub cmdPrior_Click ()
    
    data1.RecordSet.MovePrevious
    cmdNext.Enabled = True
    If data1.RecordSet.BOF Then
        data1.RecordSet.MoveFirst
        cmdPrior.Enabled = False
    End If

End Sub

Sub cmdSave_Click ()
    On Error GoTo SaveError

    data1.UpdateRecord

    cmdSave.Visible = False
    cmdCancel.Visible = False
    
    'Reset buttons to show leaving Add mode
    ReSetButtons
    
    'Disable the key field
    txtID.Enabled = False

TerminateSave:
    Exit Sub

SaveError:
    If Err = 3022 Then
        MsgBox ERROR_MSG
        txtID.SelStart = 0
        txtID.SelLength = Len(txtID.Text)
        txtID.SetFocus
    Else
        MsgBox Error$
    End If

    Resume TerminateSave

End Sub

Sub cmdUpdate_Click ()
    
    'Invoke Data1.UpdateRecord rather
    'than Data1.RecordSet.Update.
    'Data1.UpdateRecord saves a record
    'but DOES NOT invoke Validation Event.
    'We don't want to prompt user to save
    'if he or she explicitly chose Update.

    data1.UpdateRecord
    cmdUpdate.Enabled = False
End Sub

Sub Data1_Error (DataErr As Integer, response As Integer)
    Const CONTINUE = 0

    If DataErr = 3022 Then
        MsgBox ERROR_MSG
        txtID.SelStart = 0
        txtID.SelLength = Len(txtID.Text)
        txtID.SetFocus
        response = CONTINUE
    End If
End Sub

Sub Data1_Reposition ()
    cmdUpdate.Enabled = False
End Sub

Sub Data1_Validate (Action As Integer, Save As Integer)
    Const IDNO = 7
    
    If Save = True Then
        'We will prompt the user to save record
        'for all actions EXCEPT ADD.

        'If the user selected ADD then ADD again,
        'we do not want to issue prompt. (Ation 5 is Add)
        'However, if Update button is visible, that
        'means the user user modified a record
        'but has not saved it yet.
        'In this case, we should issue prompt.
        If Action <> 5 Or cmdUpdate.Enabled = True Then 'prompt on AddNew
          If MsgBox("save?", 4) = IDNO Then
              Save = False
              data1.UpdateControls
          End If
        End If
    End If
    
    If Action <> 5 Then
        'Reset Buttons to show leaving Add mode
         ReSetButtons
    End If

End Sub

Sub Form_Load ()
    'Position the form
    If app.PrevInstance = 0 Then
        top = 0
    Else
        top = screen.Height / 2
    End If
    width = screen.width
    left = 0
    
    'make Save and Cancel invisible
    cmdSave.Visible = False
    cmdCancel.Visible = False
End Sub

Sub ReSetButtons ()
    'ReEnableButtons is called whenever you Cancel
    'or save a record. It simply hides Save and Cancel
    'to show you are no longer in Add mode
    'and reenables Delete. (Delete is only valid
    'if you are not in Add mode.)

    'This routine is invoked from cmdSave, cmdCancel,
    'cmdFind and the Validation Event of data control
    cmdSave.Visible = False
    cmdCancel.Visible = False
    cmdDelete.Enabled = True

End Sub

Sub txtFirstName_KeyPress (KeyAscii As Integer)
    If cmdSave.Visible = False Then
        cmdUpdate.Enabled = True
    End If
End Sub

Sub txtLastName_KeyDown (KeyCode As Integer, Shift As Integer)
    If KeyCode = KEY_DELETE And cmdSave.Visible = False Then
        cmdUpdate.Enabled = True
    End If

End Sub

Sub txtLastName_KeyPress (KeyAscii As Integer)
    If cmdSave.Visible = False Then
        cmdUpdate.Enabled = True
    End If
End Sub

