VERSION 2.00
Begin Form frmDbase 
   Caption         =   "dBASE III: How To"
   ClientHeight    =   5040
   ClientLeft      =   1785
   ClientTop       =   1470
   ClientWidth     =   4785
   Height          =   5445
   Left            =   1725
   LinkTopic       =   "Form1"
   ScaleHeight     =   5040
   ScaleWidth      =   4785
   Top             =   1125
   Width           =   4905
   Begin Frame frmLockOptions 
      Caption         =   "Locking Options"
      Height          =   1335
      Left            =   240
      TabIndex        =   14
      Top             =   3360
      Width           =   2655
      Begin OptionButton optOptimistic 
         Caption         =   "Optimistic Locking"
         Height          =   255
         Left            =   240
         TabIndex        =   16
         Top             =   840
         Width           =   2055
      End
      Begin OptionButton optPessimistic 
         Caption         =   "Pessimistic Locking"
         Height          =   255
         Left            =   240
         TabIndex        =   15
         Top             =   360
         Width           =   2295
      End
   End
   Begin CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   375
      Left            =   3240
      TabIndex        =   13
      Top             =   4320
      Width           =   1095
   End
   Begin CommandButton cmdUpdate 
      Caption         =   "Update"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3240
      TabIndex        =   12
      Top             =   3240
      Width           =   1095
   End
   Begin CommandButton cmdEdit 
      Caption         =   "Edit"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3240
      TabIndex        =   11
      Top             =   2640
      Width           =   1095
   End
   Begin TextBox txtID 
      BackColor       =   &H00FFFFFF&
      Enabled         =   0   'False
      ForeColor       =   &H00000000&
      Height          =   285
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   1335
   End
   Begin CommandButton cmdLast 
      Caption         =   "Last"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3240
      TabIndex        =   7
      Top             =   2040
      Width           =   1100
   End
   Begin CommandButton cmdFirst 
      Caption         =   "First"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3240
      TabIndex        =   6
      Top             =   1440
      Width           =   1100
   End
   Begin CommandButton cmdPrevious 
      Caption         =   "Previous"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3240
      TabIndex        =   5
      Top             =   840
      Width           =   1100
   End
   Begin CommandButton cmdNext 
      Caption         =   "Next"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3240
      TabIndex        =   4
      Top             =   240
      Width           =   1100
   End
   Begin CommandButton cmdLoad 
      Caption         =   "Load Database"
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   2640
      Width           =   1815
   End
   Begin TextBox txtFirstName 
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   1920
      Width           =   2655
   End
   Begin TextBox txtLastName 
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   1080
      Width           =   2655
   End
   Begin Label lblID 
      Caption         =   "ID Number"
      Height          =   255
      Left            =   240
      TabIndex        =   10
      Top             =   120
      Width           =   1095
   End
   Begin Label lblFirstName 
      Caption         =   "First Name"
      Height          =   255
      Left            =   240
      TabIndex        =   9
      Top             =   1680
      Width           =   1335
   End
   Begin Label lblLastName 
      Caption         =   "Last Name"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   840
      Width           =   975
   End
End
Option Explicit

Const SIZE = 8

Dim MyCommands(SIZE) As commandbutton

Const ERROR_MSG = "You have entered an Employee ID that already exists. Modify Employee ID before proceeding."

Dim db As database
Dim tb As table

Sub cmdEdit_Click ()
    Dim i As Integer
    
    On Error GoTo EditError
    tb.Edit
    For i = 2 To 5
        MyCommands(i).Enabled = False
    Next i
    cmdEdit.Enabled = False
    cmdUpdate.Enabled = True
    
TerminateEdit:
    Exit Sub

EditError:
    Select Case Err
        Case 3260
            MsgBox "Try Later", , "Record is locked."
        Case Else
            MsgBox Err & Error$
    End Select
    Resume TerminateEdit

End Sub

Sub cmdEnd_Click ()
    
    End
End Sub

Sub cmdFirst_Click ()
    tb.MoveFirst
    PlaceDataInControls
End Sub

Sub cmdLast_Click ()
    tb.MoveLast
    PlaceDataInControls
End Sub

Sub cmdLoad_Click ()
    Dim i As Integer
    Const HOURGLASS = 11
    Const DEFAULT = 0
    
    'Load the database, and then disable button #1
    screen.MousePointer = HOURGLASS
        Set db = OpenDatabase("c:\vbdemos\data2", False, False, "dBASE III;")
        
        'For dBase III, the strings in the next 2 lines
        'are the names of the .dbf and the .ndx files, respectively.
        'It's necessary to create an .INF file that with the same
        'name as the .DBF file that lists all the database's indexes.
        Set tb = db.OpenTable("emps")
        tb.Index = "emps"
        
        PlaceDataInControls
        optPessimistic.Value = True
    screen.MousePointer = DEFAULT
    
    cmdLoad.Enabled = False
    For i = 2 To 7
        MyCommands(i).Enabled = True
    Next i
    cmdUpdate.Enabled = False
    cmdEdit.SetFocus
End Sub

Sub cmdNext_Click ()
    On Error Resume Next
    
    tb.MoveNext
    If tb.EOF Then
        tb.MoveLast
    End If
    PlaceDataInControls
End Sub

Sub cmdPrevious_Click ()
    On Error Resume Next
    
            tb.MovePrevious
            If tb.BOF Then
                tb.MoveFirst
            End If
    PlaceDataInControls

End Sub

Sub cmdUpdate_Click ()
    Dim rc As Integer, i As Integer
    On Error GoTo updateerror

    PlaceControlsInDatabase
    tb.Update
    
    For i = 2 To 5
        MyCommands(i).Enabled = True
    Next i

    cmdEdit.Enabled = True
    cmdUpdate.Enabled = False

terminatesub:
    Exit Sub

updateerror:
    Select Case Err
        Case 3022
            MsgBox ERROR_MSG
            txtID.SelStart = 0
            txtID.SelLength = Len(txtID.Text)
            txtID.SetFocus
        Case 3197
            rc = MsgBox("Another process has changed the record since you began editing. Overwrite latest record?", 36, "What you gonna do?")
            If rc = 6 Then
                Resume
            Else
                Resume Next
            End If
        Case 3260
            MsgBox "Try Later", , "Record is locked."
        Case Else
            MsgBox Err & Error$
    End Select
    Resume terminatesub
End Sub

Sub Form_Load ()
    'Stuff the command buttons into an array for easier processing.
    'NOTE: the order here is to facilitate processing the
    'buttons with a for loop, and is not exactly the order
    'the buttons appear on the screen.
    Set MyCommands(1) = cmdLoad
    
    Set MyCommands(2) = cmdNext
    Set MyCommands(3) = cmdPrevious
    Set MyCommands(4) = cmdFirst
    Set MyCommands(5) = cmdLast
    Set MyCommands(6) = cmdEdit
    Set MyCommands(7) = cmdUpdate
    
    Set MyCommands(8) = cmdEnd

    If app.PrevInstance Then
        left = screen.Width / 2
    Else
        left = 0
    End If
    top = 0
    Width = screen.Width / 2
End Sub

Sub optOptimistic_Click ()
    tb.LockEdits = False
End Sub

Sub optPessimistic_Click ()
    tb.LockEdits = True
End Sub

Sub PlaceControlsInDatabase ()
    tb!last_nam = txtLastName.Text
    tb!Firs_nam = txtFirstName.Text
End Sub

Sub PlaceDataInControls ()
    txtID.Text = tb!emp_id
    txtLastName.Text = tb!last_nam
    txtFirstName.Text = tb!Firs_nam
End Sub

