VERSION 2.00
Begin Form frmSnapshot 
   Caption         =   "Object Variables: Creating a Snapshot"
   ClientHeight    =   2970
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   6120
   Height          =   3375
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   2970
   ScaleWidth      =   6120
   Top             =   1140
   Width           =   6240
   Begin CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   375
      Left            =   1560
      TabIndex        =   7
      Top             =   2400
      Width           =   1335
   End
   Begin CommandButton cmdLast 
      Caption         =   "Last"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4920
      TabIndex        =   6
      Top             =   2160
      Width           =   975
   End
   Begin CommandButton cmdFirst 
      Caption         =   "First"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4920
      TabIndex        =   5
      Top             =   1560
      Width           =   975
   End
   Begin CommandButton cmdPrevious 
      Caption         =   "Previous"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4920
      TabIndex        =   4
      Top             =   960
      Width           =   975
   End
   Begin CommandButton cmdNext 
      Caption         =   "Next"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4920
      TabIndex        =   3
      Top             =   360
      Width           =   975
   End
   Begin CommandButton cmdLoad 
      Caption         =   "Load Database"
      Height          =   375
      Left            =   1320
      TabIndex        =   2
      Top             =   1680
      Width           =   1815
   End
   Begin TextBox txtFirstName 
      DataField       =   "First Name"
      DataSource      =   "Data1"
      Height          =   375
      Left            =   600
      TabIndex        =   1
      Top             =   960
      Width           =   3135
   End
   Begin TextBox txtLastName 
      DataField       =   "Last Name"
      DataSource      =   "Data1"
      Height          =   375
      Left            =   600
      TabIndex        =   0
      Top             =   240
      Width           =   3135
   End
End
Option Explicit

Dim db As database
Dim snp1 As snapshot

Sub cmdEnd_Click ()
    End
End Sub

Sub cmdFirst_Click ()
    snp1.MoveFirst
    PlaceDataInControls
End Sub

Sub cmdLast_Click ()
    snp1.MoveLast
    PlaceDataInControls
End Sub

Sub cmdLoad_Click ()
    'Open the database, create a snapshot, and show the first record.
    Set db = OpenDatabase("c:\vbdemos\nwind.mdb")
    Set snp1 = db.CreateSnapshot("Employees")
    PlaceDataInControls

    'Enable and disable the buttons.
    cmdLoad.Enabled = False
    cmdNext.Enabled = True
    cmdPrevious.Enabled = True
    cmdFirst.Enabled = True
    cmdLast.Enabled = True
End Sub

Sub cmdNext_Click ()
    On Error Resume Next
    
    snp1.MoveNext
    If snp1.EOF Then
        Beep
        snp1.MoveLast
    End If
    PlaceDataInControls
End Sub

Sub cmdPrevious_Click ()
    On Error Resume Next
    
    snp1.MovePrevious
    If snp1.BOF Then
        Beep
        snp1.MoveFirst
    End If
    PlaceDataInControls
End Sub

Sub PlaceDataInControls ()
    txtLastName.Text = snp1![Last Name]
    txtFirstName.Text = snp1![First Name]
End Sub

