VERSION 2.00
Begin Form frmSQLServer 
   Caption         =   "SQL Server: How To"
   ClientHeight    =   5235
   ClientLeft      =   1785
   ClientTop       =   1470
   ClientWidth     =   4785
   Height          =   5640
   Left            =   1725
   LinkTopic       =   "Form1"
   ScaleHeight     =   5235
   ScaleWidth      =   4785
   Top             =   1125
   Width           =   4905
   Begin CommandButton cmdDBX 
      Caption         =   "DBX"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3240
      TabIndex        =   17
      Top             =   3840
      Width           =   1095
   End
   Begin Frame frmLockOptions 
      Caption         =   "Locking Options"
      Height          =   1335
      Left            =   240
      TabIndex        =   14
      Top             =   3720
      Width           =   2655
      Begin OptionButton optOptimistic 
         Caption         =   "Optimistic Locking"
         Height          =   255
         Left            =   240
         TabIndex        =   16
         Top             =   840
         Width           =   2055
      End
      Begin OptionButton optPessimistic 
         Caption         =   "Pessimistic Locking"
         Height          =   255
         Left            =   240
         TabIndex        =   15
         Top             =   360
         Width           =   2295
      End
   End
   Begin CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   375
      Left            =   3240
      TabIndex        =   13
      Top             =   4680
      Width           =   1095
   End
   Begin CommandButton cmdUpdate 
      Caption         =   "Update"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3240
      TabIndex        =   12
      Top             =   3240
      Width           =   1095
   End
   Begin CommandButton cmdEdit 
      Caption         =   "Edit"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3240
      TabIndex        =   11
      Top             =   2640
      Width           =   1095
   End
   Begin TextBox txtID 
      BackColor       =   &H00FFFFFF&
      Enabled         =   0   'False
      ForeColor       =   &H00000000&
      Height          =   285
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   1335
   End
   Begin CommandButton cmdLast 
      Caption         =   "Last"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3240
      TabIndex        =   7
      Top             =   2040
      Width           =   1100
   End
   Begin CommandButton cmdFirst 
      Caption         =   "First"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3240
      TabIndex        =   6
      Top             =   1440
      Width           =   1100
   End
   Begin CommandButton cmdPrevious 
      Caption         =   "Previous"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3240
      TabIndex        =   5
      Top             =   840
      Width           =   1100
   End
   Begin CommandButton cmdNext 
      Caption         =   "Next"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3240
      TabIndex        =   4
      Top             =   240
      Width           =   1100
   End
   Begin CommandButton cmdLoad 
      Caption         =   "Load Database"
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   2640
      Width           =   1815
   End
   Begin TextBox txtFirstName 
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   1920
      Width           =   2655
   End
   Begin TextBox txtLastName 
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   1080
      Width           =   2655
   End
   Begin Label lblID 
      Caption         =   "ID Number"
      Height          =   255
      Left            =   240
      TabIndex        =   10
      Top             =   120
      Width           =   1095
   End
   Begin Label lblFirstName 
      Caption         =   "First Name"
      Height          =   255
      Left            =   240
      TabIndex        =   9
      Top             =   1680
      Width           =   1335
   End
   Begin Label lblLastName 
      Caption         =   "Last Name"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   840
      Width           =   975
   End
End
Option Explicit

Const SIZE = 9

Dim MyCommands(SIZE) As commandbutton

Const ERROR_MSG = "You have entered an Employee ID that already exists. Modify Employee ID before proceeding."

Dim db As database

Dim ds As dynaset

Sub cmdDBX_Click ()
    Dim rc As Integer
    rc = db.ExecuteSQL("exec sp_addlogin 'davidch', 'pw', 'pubs'")
End Sub

Sub cmdEdit_Click ()
    Dim i As Integer
    
    On Error GoTo EditError
    ds.Edit
    For i = 2 To 8
        MyCommands(i).Enabled = False
    Next i
    cmdUpdate.Enabled = True
    
TerminateEdit:
    Exit Sub

EditError:
    Select Case Err
        Case 3260
            MsgBox "Try Later", , "Record is locked."
        Case Else
            MsgBox Err & Error$
    End Select
    Resume TerminateEdit

End Sub

Sub cmdEnd_Click ()
    Unload frmSQLServer
End Sub

Sub cmdFirst_Click ()
    ds.MoveFirst
    PlaceDataInControls
End Sub

Sub cmdLast_Click ()
    ds.MoveLast
    PlaceDataInControls
End Sub

Sub cmdLoad_Click ()
    Dim i As Integer
    Dim dbconnect As String, server As String
   
    Const HOURGLASS = 11
    Const DEFAULT = 0
    
    'Load the database, and then disable button #1
    screen.MousePointer = HOURGLASS
        dbconnect = "ODBC;UID=davidch;PWD=pw;DBQ=pubs;DSN=patrici;"
        server = ""
        'The server string is null if the server name is embedded
        'in the connect string by using the DSN keyword.
        Set db = OpenDatabase(server, False, False, dbconnect)
        
        'Another way of invoking OpenDatabase is to make it invoke a
        'dialog box that obtains all the required information from the user.
        'server = "patrici"
        'Set db = OpenDatabase(server, False, False, "ODBC")

        Set ds = db.CreateDynaset("authors")
        PlaceDataInControls
        optPessimistic.Value = True
    screen.MousePointer = DEFAULT
    
    cmdLoad.Enabled = False
    For i = 2 To 8
        MyCommands(i).Enabled = True
    Next i
    cmdUpdate.Enabled = False
    cmdEdit.SetFocus
End Sub

Sub cmdNext_Click ()
    On Error Resume Next
    
    ds.MoveNext
    If ds.EOF Then
        ds.MoveLast
    End If
    PlaceDataInControls
End Sub

Sub cmdPrevious_Click ()
    On Error Resume Next
    
            ds.MovePrevious
            If ds.BOF Then
                ds.MoveFirst
            End If
    PlaceDataInControls

End Sub

Sub cmdUpdate_Click ()
    Dim rc As Integer, i As Integer
    On Error GoTo updateerror

    PlaceControlsInDatabase
    ds.Update
    
    For i = 2 To 8
        MyCommands(i).Enabled = True
    Next i
    cmdUpdate.Enabled = False

terminatesub:
    Exit Sub

updateerror:
    Select Case Err
        Case 3022
            MsgBox ERROR_MSG
            txtID.SelStart = 0
            txtID.SelLength = Len(txtID.Text)
            txtID.SetFocus
        Case 3197
            rc = MsgBox("Another process has changed the record since you began editing. Overwrite latest record?", 36, "What you gonna do?")
            If rc = 6 Then
                Resume
            Else
                Resume Next
            End If
        Case 3260
            MsgBox "Try Later", , "Record is locked."
        Case Else
            MsgBox Err & Error$
    End Select
    Resume terminatesub
End Sub

Sub Form_Load ()
    'Stuff the command buttons into an array for easier processing.
    'NOTE: the order here is to facilitate processing the
    'buttons with a for loop, and is not exactly the order
    'the buttons appear on the screen.
    Set MyCommands(1) = cmdLoad
    
    Set MyCommands(2) = cmdNext
    Set MyCommands(3) = cmdPrevious
    Set MyCommands(4) = cmdFirst
    Set MyCommands(5) = cmdLast
    Set MyCommands(6) = cmdEdit
    Set MyCommands(7) = cmdUpdate
    Set MyCommands(8) = cmdDBX
    
    Set MyCommands(9) = cmdEnd

    If app.PrevInstance Then
        left = screen.Width / 2
    Else
        left = 0
    End If
    top = 0
    Width = screen.Width / 2
End Sub

Sub optOptimistic_Click ()
    ds.LockEdits = False
End Sub

Sub optPessimistic_Click ()
    ds.LockEdits = True
End Sub

Sub PlaceControlsInDatabase ()
    ds!au_lname = txtLastName.Text
    ds!au_fname = txtFirstName.Text
End Sub

Sub PlaceDataInControls ()
    txtID.Text = ds!au_id
    txtLastName.Text = ds!au_lname
    txtFirstName.Text = ds!au_fname
End Sub

