VERSION 2.00
Begin Form Form1 
   BackColor       =   &H00FFFFFF&
   Caption         =   "Using BITBLT to Paint a Region on a Form"
   ClientHeight    =   2385
   ClientLeft      =   1845
   ClientTop       =   2295
   ClientWidth     =   5475
   Height          =   2790
   Icon            =   0
   Left            =   1785
   LinkTopic       =   "Form1"
   ScaleHeight     =   159
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   365
   Top             =   1950
   Width           =   5595
   Begin CommandButton Command2 
      BackColor       =   &H00FFFFFF&
      Caption         =   "End"
      Height          =   495
      Left            =   240
      TabIndex        =   2
      Top             =   1200
      Width           =   1215
   End
   Begin CommandButton Command1 
      Caption         =   "Command(1)"
      Height          =   375
      Index           =   1
      Left            =   240
      TabIndex        =   1
      Top             =   600
      Width           =   1215
   End
   Begin PictureBox Picture1 
      AutoSize        =   -1  'True
      Height          =   360
      Left            =   3360
      Picture         =   BITBLT.FRX:0000
      ScaleHeight     =   22
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   24
      TabIndex        =   0
      Top             =   0
      Width           =   390
   End
End
Option Explicit

Declare Function BitBlt Lib "GDI" (ByVal hDestDC As Integer, ByVal x As Integer, ByVal y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hSrcDC As Integer, ByVal XSrc As Integer, ByVal YSrc As Integer, ByVal dwRop As Long) As Integer

Const DELTA = 100

Const PIXEL = 3

Const RASTER_COUNT = 8

Dim RasterStrings(RASTER_COUNT) As String
Dim RasterValues(RASTER_COUNT) As Long

'These are the allowable constants for the final argument to BitBlt()

Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Const SRCAND = &H8800C6  ' (DWORD) dest = source AND dest
Const SRCINVERT = &H660046   ' (DWORD) dest = source XOR dest
Const SRCERASE = &H440328    ' (DWORD) dest = source AND (NOT dest )
Const NOTSRCCOPY = &H330008  ' (DWORD) dest = (NOT source)
Const NOTSRCERASE = &H1100A6 ' (DWORD) dest = (NOT src) AND (NOT dest)
Const DSTINVERT = &H550009   ' (DWORD) dest = (NOT dest)
Const BLACKNESS = &H42&  ' (DWORD) dest = BLACK

'Const SRCPAINT = &HEE0086    ' (DWORD) dest = source OR dest
'Const MERGECOPY = &HC000CA   ' (DWORD) dest = (source AND pattern)
'Const MERGEPAINT = &HBB0226  ' (DWORD) dest = (NOT source) OR dest
'Const PATCOPY = &HF00021 ' (DWORD) dest = pattern
'Const PATPAINT = &HFB0A09    ' (DWORD) dest = DPSnoo
'Const PATINVERT = &H5A0049   ' (DWORD) dest = pattern XOR dest
'Const WHITENESS = &HFF0062   ' (DWORD) dest = WHITE

Sub Command1_Click (index As Integer)
    Dim x As Integer, y As Integer
    
    x = command1(index).Left + 150
    y = command1(index).top
    
    Call DoTheBitBlt(RasterValues(index), x, y)

End Sub

Sub Command2_Click ()
    End
End Sub

Sub DoTheBitBlt (method As Long, dstx As Integer, dsty As Integer)
    Dim rc As Integer
    Dim srcW As Integer
    Dim srcH As Integer

    srcW = Picture1.Width
    srcH = Picture1.Height
    
    rc = BitBlt(hDC, dstx, dsty, srcW, srcH, Picture1.hDC, 0, 0, method)
End Sub

Sub Form_Load ()
    Const increment = 60
    Dim i As Integer

    RasterStrings(1) = "SRC COPY"
    RasterStrings(2) = "SRC AND"
    RasterStrings(3) = "SRC INVERT"
    RasterStrings(4) = "SRC ERASE"
    RasterStrings(5) = "NOT SRC COPY"
    RasterStrings(6) = "NOT SRC ERASE"
    RasterStrings(7) = "DST INVERT"
    RasterStrings(8) = "BLACKNESS"
    
    'RasterStrings(9) = "SRC PAINT"
    'RasterStrings(10) = "MERGE COPY"
    'RasterStrings(11) = "MERGE PAINT"
    'RasterStrings(12) = "PAT COPY"
    'RasterStrings(13) = "PAT PAINT"
    'RasterStrings(14) = "PAT INVERT"
    'RasterStrings(15) = "WHITENESS"

    RasterValues(1) = SRCCOPY
    RasterValues(2) = SRCAND
    RasterValues(3) = SRCINVERT
    RasterValues(4) = SRCERASE
    RasterValues(5) = NOTSRCCOPY
    RasterValues(6) = NOTSRCERASE
    RasterValues(7) = DSTINVERT
    RasterValues(8) = BLACKNESS
    
    'RasterValues(9) = SRCPAINT
    'RasterValues(10) = MERGECOPY
    'RasterValues(11) = MERGEPAINT
    'RasterValues(12) = PATCOPY
    'RasterValues(13) = PATPAINT
    'RasterValues(14) = PATINVERT
    'RasterValues(15) = WHITENESS
    
    
    form1.ScaleMode = PIXEL
    form1.Height = .9 * screen.Height
    form1.Width = .9 * screen.Width
    form1.top = (screen.Width - form1.Width) / 2
    form1.Left = (screen.Height - form1.Height) / 2

    command1(1).Caption = RasterStrings(1)
    command1(1).Height = TextHeight("123") * 1.5
    command1(1).Width = 110
    
    For i = 2 To RASTER_COUNT
	Load command1(i)
	If i = (RASTER_COUNT / 2 + 1) Then
	    command1(i).top = command1(1).top
	    command1(i).Left = form1.scalewidth / 2
	Else
	    command1(i).top = command1(i - 1).top + increment
	    command1(i).Left = command1(i - 1).Left
	End If
	command1(i).Visible = True
	command1(i).Caption = RasterStrings(i)
    Next i

    command2.Left = command1(RASTER_COUNT).Left
    command2.top = command1(RASTER_COUNT).top + increment
    command2.Height = command1(RASTER_COUNT).Height + 1.25

End Sub

