VERSION 2.00
Begin Form Form1 
   Caption         =   "Setting Focus to Invalid Field"
   ClientHeight    =   4020
   ClientLeft      =   1560
   ClientTop       =   1515
   ClientWidth     =   5175
   Height          =   4425
   Left            =   1500
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   4020
   ScaleWidth      =   5175
   Top             =   1170
   Width           =   5295
   Begin TextBox txtNumber 
      Height          =   375
      Left            =   2520
      TabIndex        =   3
      Tag             =   "txtNumber"
      Top             =   1440
      Width           =   1695
   End
   Begin TextBox txtName 
      Height          =   375
      Left            =   2520
      TabIndex        =   1
      Tag             =   "txtName"
      Top             =   600
      Width           =   1695
   End
   Begin CommandButton Command2 
      Caption         =   "Cancel"
      Height          =   615
      Left            =   3120
      TabIndex        =   5
      Top             =   2400
      Width           =   1455
   End
   Begin CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   615
      Left            =   600
      TabIndex        =   4
      Top             =   2400
      Width           =   1215
   End
   Begin Label lblError 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   720
      TabIndex        =   7
      Top             =   120
      Visible         =   0   'False
      Width           =   3495
   End
   Begin Label Label1 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Name"
      Height          =   195
      Left            =   1080
      TabIndex        =   0
      Top             =   600
      Width           =   495
   End
   Begin Label Label2 
      Alignment       =   1  'Right Justify
      AutoSize        =   -1  'True
      Caption         =   "Number 1-50"
      Height          =   195
      Left            =   720
      TabIndex        =   2
      Top             =   1560
      Width           =   1095
   End
   Begin Label Label4 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "OK button will set focus to first invalid text box, if any."
      Height          =   495
      Left            =   1080
      TabIndex        =   6
      Top             =   3360
      Width           =   3135
   End
End
Option Explicit

Const MSK_COUNT = 2

Dim ValidFlags(MSK_COUNT) As Integer

Sub cmdOK_Click ()
    Dim lcv As Integer

    'It's necessary to force a LostFocus for the current control
    'by setting the focus to this control. This in turn invokes
    'DetermineValidity for that control.
    cmdOK.SetFocus
    
    For lcv = 0 To MSK_COUNT
        If ValidFlags(lcv) = False Then
            Exit For
        End If
    Next lcv

    Select Case lcv
        Case 0
            lblError.Caption = "Name is not valid!"
            lblError.Visible = True
            txtName.SetFocus
        Case 1
            lblError.Caption = "Number is not between 1 and 50!"
            lblError.Visible = True
            txtNumber.SetFocus
        Case Else
            MsgBox "All fields are OK"
            Exit Sub
    End Select
End Sub

Sub Command2_Click ()
    End
End Sub

Sub DetermineValidity (CurrentControl As Control)
    Dim Temp As Integer

    Select Case CurrentControl.Tag
        Case "txtName"
            If txtName.Text <> "" Then
                ValidFlags(0) = True
            Else
                ValidFlags(0) = False
            End If
        Case "txtNumber"
            Temp = Val(txtNumber.Text)
            If (Temp >= 1 And Temp <= 50) Then
                ValidFlags(1) = True
            Else
                ValidFlags(1) = False
            End If
    End Select
    lblError.Visible = False
End Sub

Sub txtName_LostFocus ()
    DetermineValidity txtName
End Sub

Sub txtNumber_LostFocus ()
    DetermineValidity txtNumber
End Sub

