VERSION 2.00
Begin Form Form1 
   Caption         =   "ValidationError, or Run Time Error?"
   ClientHeight    =   4560
   ClientLeft      =   1095
   ClientTop       =   1815
   ClientWidth     =   6615
   Height          =   4965
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   4560
   ScaleWidth      =   6615
   Top             =   1470
   Width           =   6735
   Begin CommandButton Command3 
      Caption         =   "Reset"
      Height          =   615
      Left            =   2520
      TabIndex        =   9
      Top             =   3600
      Width           =   1455
   End
   Begin CommandButton Command2 
      Caption         =   "End"
      Height          =   615
      Left            =   4440
      TabIndex        =   6
      Top             =   3600
      Width           =   1215
   End
   Begin CommandButton Command1 
      Caption         =   "ASSIGN!"
      Height          =   615
      Left            =   960
      TabIndex        =   5
      Top             =   3600
      Width           =   1215
   End
   Begin TextBox Text1 
      Height          =   380
      Left            =   4080
      TabIndex        =   1
      Text            =   "12345Hello"
      Top             =   480
      Width           =   1215
   End
   Begin MaskEdBox MaskedEdit1 
      Height          =   380
      Left            =   960
      Mask            =   "##########"
      MaxLength       =   10
      PromptChar      =   "_"
      TabIndex        =   0
      Top             =   480
      Width           =   1335
   End
   Begin Label Label5 
      Caption         =   "Run Time error"
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   1800
      Width           =   1335
   End
   Begin Label Label4 
      Caption         =   "ValidationError"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   1200
      Width           =   1335
   End
   Begin Label lblError2 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Left            =   1560
      TabIndex        =   8
      Top             =   1800
      Visible         =   0   'False
      Width           =   4335
   End
   Begin Label lblError 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   615
      Left            =   1560
      TabIndex        =   7
      Top             =   1080
      Visible         =   0   'False
      Width           =   4335
   End
   Begin Label Label3 
      Alignment       =   2  'Center
      Caption         =   "The Masked Edit Control  will accept only digits. Set the focus to it and try to enter some letters. Then, click on the command button to assign the contents of the text box to the masked edit control. This will generate both a ValidationError event and a run time error."
      Height          =   975
      Left            =   600
      TabIndex        =   4
      Top             =   2400
      Width           =   5055
   End
   Begin Label Label2 
      Caption         =   "Ordinary Text Box"
      Height          =   260
      Left            =   4080
      TabIndex        =   3
      Top             =   120
      Width           =   1815
   End
   Begin Label Label1 
      Caption         =   "Masked Edit Control"
      Height          =   260
      Left            =   960
      TabIndex        =   2
      Top             =   120
      Width           =   1815
   End
End
Option Explicit

Sub Command1_Click ()
    On Error GoTo error_handler
    maskededit1.Text = text1.Text
    Exit Sub

error_handler:
    lblError2.Caption = "error #" + Str$(Err)
    lblError2.Visible = True
    Resume Next
End Sub

Sub Command1_LostFocus ()
    lblError.Visible = False
    lblError2.Visible = False
End Sub

Sub Command2_Click ()
    maskededit1.Text = "0123456789"
    End
End Sub

Sub Command3_Click ()
    lblError.Visible = False
    lblError2.Visible = False
    maskededit1.Text = "__________"
    maskededit1.SetFocus
End Sub

Sub MaskedEdit1_KeyPress (keyascii As Integer)
    'Accept digits and the backspace
    If (keyascii >= 48 And keyascii <= 57) Or keyascii = 8 Then
        lblError.Visible = False
    End If
End Sub

Sub MaskedEdit1_LostFocus ()
    'Never display the error when focus is lost
    lblError.Visible = False
End Sub

Sub MaskedEdit1_ValidationError (InvalidText As String, startposition As Integer)
    Dim crlf As String
    Dim myMsg As String

    crlf = Chr$(13) + Chr$(10)
    myMsg = "Digits Only. Error at position " + Str$(startposition + 1)
    myMsg = myMsg + crlf + "Invalid text is " + InvalidText

    lblError.Caption = myMsg
    lblError.Visible = True
End Sub

