VERSION 2.00
Begin Form Form1 
   Caption         =   "Splitting Sentences"
   ClientHeight    =   4890
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   7365
   Height          =   5295
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   4890
   ScaleWidth      =   7365
   Top             =   1140
   Width           =   7485
   Begin CommandButton Command3 
      Caption         =   "Reset"
      Height          =   615
      Left            =   2880
      TabIndex        =   6
      Top             =   3960
      Width           =   1575
   End
   Begin CommandButton Command2 
      Caption         =   "End"
      Height          =   615
      Left            =   5760
      TabIndex        =   5
      Top             =   3960
      Width           =   1335
   End
   Begin CommandButton Command1 
      Caption         =   "Do It!"
      Height          =   615
      Left            =   480
      TabIndex        =   4
      Top             =   3960
      Width           =   1335
   End
   Begin ListBox List2 
      Height          =   1005
      Left            =   4200
      TabIndex        =   3
      Top             =   2400
      Width           =   2895
   End
   Begin ListBox List1 
      Height          =   1005
      Left            =   480
      TabIndex        =   2
      Top             =   2400
      Width           =   2775
   End
   Begin TextBox Text1 
      Height          =   735
      Left            =   480
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   1320
      Width           =   6615
   End
   Begin Label Label1 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Type in 2 sentences. END BOTH SENTENCES WITH A PERIOD! The words from the first sentence will be placed in the left list box; the words from the second sentence will be placed in the right list box. This requires using the Visual Basic functions InStr, Mid$, Right$, Left$, and Trim$."
      Height          =   855
      Left            =   480
      TabIndex        =   0
      Top             =   240
      Width           =   6615
   End
End
Option Explicit

Sub Command1_Click ()
    Dim sentence1 As String, sentence2 As String
    Dim CurrentWord As String
    Dim posSpace As Integer, CurrentPos As Integer, posperiod As Integer

    'Find the period
    posperiod = InStr(text1.text, ".")
    If posperiod = 0 Then
        MsgBox "You didn't follow punctuation instructions!"
        Exit Sub
    End If

    'Grab the 2 sentences, and strip off trailing and leading spaces.
    sentence1 = Left$(text1.text, posperiod)
    sentence1 = Trim$(sentence1)

    sentence2 = Right$(text1.text, Len(text1.text) - posperiod)
    sentence2 = Trim$(sentence2)

    'Split Sentence 1 into its words and stuff them into the list box.
    
    'Replace the sentence punctuator (.!?) with a space.
    Mid$(sentence1, Len(sentence1), 1) = " "
    
    'Start at position 1
    CurrentPos = 1
    
    'Find the first space.
    posSpace = InStr(CurrentPos, sentence1, " ")
    
    'Stuff all the words into the list box.
    While (posSpace <> 0)
        'Extract the word
        CurrentWord = Mid$(sentence1, CurrentPos, posSpace - CurrentPos)
        
        'Add it to the list box
        list1.AddItem CurrentWord
        
        'Advance to the position 1 beyond the found space.
        CurrentPos = posSpace + 1
        
        'Grab the next word.
        posSpace = InStr(CurrentPos, sentence1, " ")
    Wend
    
    'Do the same for Sentence 2
    Mid$(sentence2, Len(sentence2), 1) = " "
    CurrentPos = 1
    posSpace = InStr(CurrentPos, sentence2, " ")
    While (posSpace <> 0)
        CurrentWord = Mid$(sentence2, CurrentPos, posSpace - CurrentPos)
        list2.AddItem CurrentWord
        CurrentPos = posSpace + 1
        posSpace = InStr(CurrentPos, sentence2, " ")
    Wend

End Sub

Sub Command2_Click ()
    End
End Sub

Sub Command3_Click ()
    text1.text = ""
    list1.Clear
    list2.Clear
    text1.SetFocus
End Sub

