VERSION 2.00
Begin Form Form1 
   Caption         =   "Icon Art Critic"
   ClientHeight    =   4980
   ClientLeft      =   1440
   ClientTop       =   1800
   ClientWidth     =   7365
   Height          =   5670
   Left            =   1380
   LinkTopic       =   "Form1"
   ScaleHeight     =   4980
   ScaleWidth      =   7365
   Top             =   1170
   Width           =   7485
   Begin PictureBox Picture4 
      Height          =   495
      Left            =   720
      Picture         =   ARTCRIT1.FRX:0000
      ScaleHeight     =   465
      ScaleWidth      =   465
      TabIndex        =   3
      Top             =   4200
      Visible         =   0   'False
      Width           =   495
   End
   Begin PictureBox Picture2 
      AutoSize        =   -1  'True
      Height          =   510
      Left            =   0
      Picture         =   ARTCRIT1.FRX:0302
      ScaleHeight     =   480
      ScaleWidth      =   480
      TabIndex        =   2
      Top             =   4200
      Visible         =   0   'False
      Width           =   510
   End
   Begin CommandButton Command2 
      Caption         =   "Show Icons"
      Enabled         =   0   'False
      Height          =   615
      Left            =   1920
      TabIndex        =   0
      Top             =   4200
      Width           =   1815
   End
   Begin Image Image2 
      Height          =   1095
      Left            =   6000
      Picture         =   ARTCRIT1.FRX:0604
      Stretch         =   -1  'True
      Top             =   3720
      Width           =   1215
   End
   Begin Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Grab an Icon and Show Your Aesthetic Judgment Here ->"
      Height          =   615
      Left            =   4080
      TabIndex        =   1
      Top             =   3960
      Width           =   1935
   End
   Begin Image Image1 
      DragMode        =   1  'Automatic
      Height          =   480
      Index           =   0
      Left            =   0
      Top             =   0
      Width           =   480
   End
   Begin Menu mnuFile 
      Caption         =   "&File"
      Begin Menu mnuEditOpen 
         Caption         =   "&Open"
      End
      Begin Menu mnuEditExit 
         Caption         =   "E&xit"
      End
   End
End
Option Explicit

Dim pic_count As Integer

' DragOver
Const ENTER = 0
Const LEAVE = 1
Const OVER = 2

Const DEFAULT = 0        ' 0 - Default
Const ARROW = 1          ' 1 - Arrow
Const CROSSHAIR = 2      ' 2 - Cross
Const IBEAM = 3          ' 3 - I-Beam
Const ICON_POINTER = 4   ' 4 - Icon
Const SIZE_POINTER = 5   ' 5 - Size
Const SIZE_NE_SW = 6     ' 6 - Size NE SW
Const SIZE_N_S = 7       ' 7 - Size N S
Const SIZE_NW_SE = 8     ' 8 - Size NW SE
Const SIZE_W_E = 9       ' 9 - Size W E
Const UP_ARROW = 10      ' 10 - Up Arrow
Const HOURGLASS = 11     ' 11 - Hourglass
Const NO_DROP = 12       ' 12 - No drop

Sub clear_icons ()
    Dim i As Integer
    
    'Set the image control array back to just 1 control
    For i = 1 To pic_count
	Unload image1(i)
    Next i
    
    image1(0).Visible = False
    pic_count = 0
End Sub

Sub Command2_Click ()
    Dim i As Integer, rc As Integer
    Dim mytop As Integer, myleft As Integer
    Dim widthdelta As Integer, heightdelta As Integer
    
    Dim fname As String
    
    widthdelta = 600: heightdelta = 500
    mytop = 100: myleft = -widthdelta + 100
    
    clear_icons

    'Next, pull the files into the image controls.
    screen.MousePointer = HOURGLASS
    pic_count = form2.File1.ListCount - 1
    For i = 0 To pic_count
	If i <> 0 Then Load image1(i)
	image1(i).Left = myleft
	If image1(i).Left > Form1.ScaleWidth - 2 * widthdelta Then
	    myleft = 100
	    mytop = mytop + heightdelta
	Else
	    myleft = myleft + widthdelta
	End If
	image1(i).Left = myleft
	image1(i).Top = mytop
	fname = form2.Dir1
	If Right$(fname, 1) <> "\" Then
	    fname = fname + "\"
	End If
	fname = fname + form2.File1.List(i)

	image1(i).picture = LoadPicture(fname)
	'It's very important to establish the dragicon at this time
	image1(i).dragicon = image1(i).picture
    Next i
    
    'Now that they're all in memory, show 'em.
    For i = 0 To pic_count
	image1(i).Visible = True
    Next i
    
    screen.MousePointer = DEFAULT
    command2.Enabled = False
End Sub

Sub Form_Load ()
    Load form2
    pic_count = 0
End Sub

Sub Image2_DragDrop (source As Control, X As Single, Y As Single)
    If TypeOf source Is image Then
	source.Visible = False
	Beep
    End If
End Sub

Sub Image2_DragOver (source As Control, X As Single, Y As Single, State As Integer)
    If State = ENTER Then
	If TypeOf source Is image Then
	    source.dragicon = Picture2.picture
	End If
	Exit Sub
    End If
    If State = LEAVE Then
	If TypeOf source Is image Then
	    source.dragicon = source.picture
	End If
    End If
End Sub

Sub Label1_DragDrop (source As Control, X As Single, Y As Single)
    'If the user DOES drop it here, restore its drag icon.
    If TypeOf source Is image Then
	source.dragicon = source.picture
    End If
End Sub

Sub Label1_DragOver (source As Control, X As Single, Y As Single, State As Integer)
    If State = ENTER Then
	If TypeOf source Is image Then
	    source.dragicon = Picture4.picture
	End If
	Exit Sub
    End If
    If State = LEAVE Then
	If TypeOf source Is image Then
	    source.dragicon = source.picture
	End If
    End If
End Sub

Sub mnuEditExit_Click ()
    End
End Sub

Sub mnuEditOpen_Click ()
    clear_icons
    form2.Dir1.Path = "c:\vb\icons"
    form2.Show
End Sub

