VERSION 2.00
Begin Form Form1 
   Caption         =   "Reading and Saving an Embedded Object"
   ClientHeight    =   4185
   ClientLeft      =   1095
   ClientTop       =   1770
   ClientWidth     =   7905
   Height          =   4875
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   4185
   ScaleWidth      =   7905
   Top             =   1140
   Width           =   8025
   Begin CommonDialog CMDialog1 
      Left            =   240
      Top             =   120
   End
   Begin OLE OLE1 
      Class           =   "ExcelWorksheet"
      fFFHk           =   -1  'True
      Height          =   555
      Left            =   1680
      OleObjectBlob   =   OLE2.FRX:0000
      SizeMode        =   2  'AutoSize
      TabIndex        =   1
      Top             =   1320
      Width           =   1455
   End
   Begin Label lblVerbs 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "There are 3 ways to activate an OLE object: double click on it with the left mouse button, or click on it with the right mouse button, and select from the pop-up menu. Or, you may select Activate from the Edit menu."
      Height          =   855
      Left            =   1320
      TabIndex        =   0
      Top             =   120
      Width           =   4935
   End
   Begin Menu mnuFile 
      Caption         =   "&File"
      Begin Menu mnuFileNew 
         Caption         =   "&New"
      End
      Begin Menu mnuFileSep1 
         Caption         =   "-"
      End
      Begin Menu mnuFileRead 
         Caption         =   "&Read"
      End
      Begin Menu mnuFileSave 
         Caption         =   "&Save"
      End
      Begin Menu mnuFileSep2 
         Caption         =   "-"
      End
      Begin Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin Menu mnuEdit 
      Caption         =   "&Edit"
      Begin Menu mnuEditActivate 
         Caption         =   "Activate Object"
      End
      Begin Menu mnuEditToggle 
         Caption         =   "Toggle AutoActivate"
      End
   End
End
Option Explicit

Dim dirtyflag As Integer

Const ID_YES = 6

'OLE Actions
Const OLE_CREATE_EMBED = 0
Const OLE_CREATE_NEW = 0
Const OLE_CREATE_LINK = 1
Const OLE_CREATE_FROM_FILE = 1
Const OLE_COPY = 4
Const OLE_PASTE = 5
Const OLE_UPDATE = 6
Const OLE_ACTIVATE = 7
Const OLE_CLOSE = 9
Const OLE_DELETE = 10
Const OLE_SAVE_TO_FILE = 11
Const OLE_READ_FROM_FILE = 12
Const OLE_INSERT_OBJ_DLG = 14
Const OLE_PASTE_SPECIAL_DLG = 15
Const OLE_FETCH_VERBS = 17
Const OLE_SAVE_TO_OLE1FILE = 18

'OLEType
Const OLE_LINKED = 0
Const OLE_EMBEDDED = 1
Const OLE_NONE = 3

'OLETypeAllowed
Const OLE_EITHER = 2

'UpdateOptions
Const OLE_AUTOMATIC = 0
Const OLE_FROZEN = 1
Const OLE_MANUAL = 2

'AutoActivate modes
Const OLE_ACTIVATE_MANUAL = 0
Const OLE_ACTIVATE_GETFOCUS = 1
Const OLE_ACTIVATE_DOUBLECLICK = 2

'SizeModes
Const OLE_SIZE_CLIP = 0
Const OLE_SIZE_STRETCH = 1
Const OLE_SIZE_AUTOSIZE = 2

'DisplayTypes
Const OLE_DISPLAY_CONTENT = 0
Const OLE_DISPLAY_ICON = 1

'Update Event Constants
Const OLE_CHANGED = 0
Const OLE_SAVED = 1
Const OLE_CLOSED = 2
Const OLE_RENAMED = 3

'Special Verb Values
Const VERB_PRIMARY = 0
Const VERB_SHOW = -1
Const VERB_OPEN = -2
Const VERB_HIDE = -3

'VerbFlag Bit Masks
Const VF_GRAYED = &H1
Const VF_DISABLED = &H2
Const VF_CHECKED = &H8
Const VF_SEPARATOR = &H800

Sub mnuEditActivate_Click ()
    ole1.Action = OLE_ACTIVATE
End Sub

Sub mnuEditToggle_Click ()
    Const TOGGLE = OLE_ACTIVATE_MANUAL Xor OLE_ACTIVATE_DOUBLECLICK
    
    ole1.AutoActivate = ole1.AutoActivate Xor TOGGLE
End Sub

Sub mnuFileExit_Click ()
    Unload form1
End Sub

Sub mnuFileNew_Click ()
    Dim rc As Integer
    If dirtyflag = True Then
        rc = MsgBox("Object has changed. Save it?", 36, "Embedded OLE")
        If rc = 6 Then
            mnuFileSave_Click
        End If
    End If
    ole1.Action = OLE_CREATE_NEW
End Sub

Sub mnuFileRead_Click ()
    Dim rc As Integer
    Dim fhandle As Integer
    Dim fname As String

    If dirtyflag = True Then
        rc = MsgBox("Object has changed. Save it?", 36, "Embedded OLE")
        If rc = ID_YES Then
            mnuFileSave_Click
        End If
    End If
    
    cmdialog1.Filter = "OLE Objects|*.ole|All files|*.*"
    cmdialog1.Action = 1
    fname = cmdialog1.Filename
    If fname = "" Then
        Exit Sub
    End If

    fhandle = FreeFile
    Open fname For Binary As fhandle
    ole1.FileNumber = fhandle
    ole1.Action = OLE_READ_FROM_FILE
    dirtyflag = False
    
    Close fhandle
End Sub

Sub mnuFileSave_Click ()
    Dim fhandle As Integer
    Dim fname As String

    cmdialog1.Filter = "OLE Objects|*.ole|All files|*.*"
    cmdialog1.Action = 2
    fname = cmdialog1.Filename
    If fname = "" Then
        Exit Sub
    End If

    fhandle = FreeFile
    Open fname For Binary As fhandle
    ole1.FileNumber = fhandle
    ole1.Action = OLE_SAVE_TO_FILE
    dirtyflag = False
    
    Close fhandle
End Sub

Sub OLE1_Updated (Code As Integer)
    dirtyflag = True
End Sub

