VERSION 2.00
Begin Form frmOle3 
   Caption         =   "Creating and Changing a Linked Object at Run Time"
   ClientHeight    =   4905
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   7950
   Height          =   5310
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   4905
   ScaleWidth      =   7950
   Top             =   1140
   Width           =   8070
   Begin CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   495
      Left            =   6240
      TabIndex        =   9
      Top             =   4080
      Width           =   1215
   End
   Begin OLE OLE1 
      fFFHk           =   -1  'True
      Height          =   2295
      Left            =   3960
      SizeMode        =   2  'AutoSize
      TabIndex        =   8
      Top             =   840
      Width           =   3495
   End
   Begin Frame fraOptions 
      Caption         =   "Viewing Options"
      Enabled         =   0   'False
      Height          =   1815
      Left            =   360
      TabIndex        =   3
      Top             =   2760
      Width           =   2415
      Begin OptionButton optQuadrant 
         Caption         =   "View Quadrant 4"
         Height          =   255
         Index           =   4
         Left            =   240
         TabIndex        =   7
         Top             =   1440
         Width           =   1815
      End
      Begin OptionButton optQuadrant 
         Caption         =   "View Quadrant 3"
         Height          =   195
         Index           =   3
         Left            =   240
         TabIndex        =   6
         Top             =   1080
         Width           =   1935
      End
      Begin OptionButton optQuadrant 
         Caption         =   "View Quadrant 2"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   5
         Top             =   720
         Width           =   1815
      End
      Begin OptionButton optQuadrant 
         Caption         =   "View Quadrant 1"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   4
         Top             =   360
         Width           =   1815
      End
   End
   Begin CommandButton cmdAction 
      Caption         =   "Establish Link"
      Enabled         =   0   'False
      Height          =   495
      Left            =   360
      TabIndex        =   2
      Top             =   1920
      Width           =   2535
   End
   Begin CommandButton cmdSource 
      Caption         =   "Specify Source Document"
      Enabled         =   0   'False
      Height          =   495
      Left            =   360
      TabIndex        =   1
      Top             =   1080
      Width           =   2535
   End
   Begin CommandButton cmdClass 
      Caption         =   "Create Class"
      Height          =   495
      Left            =   360
      TabIndex        =   0
      Top             =   240
      Width           =   2535
   End
   Begin Label Label1 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "An Empty OLE Object"
      Height          =   255
      Left            =   4800
      TabIndex        =   10
      Top             =   360
      Width           =   2055
   End
End
Option Explicit

'OLE Actions
Const OLE_CREATE_EMBED = 0
Const OLE_CREATE_NEW = 0
Const OLE_CREATE_LINK = 1
Const OLE_CREATE_FROM_FILE = 1
Const OLE_COPY = 4
Const OLE_PASTE = 5
Const OLE_UPDATE = 6
Const OLE_ACTIVATE = 7
Const OLE_CLOSE = 9
Const OLE_DELETE = 10
Const OLE_SAVE_TO_FILE = 11
Const OLE_READ_FROM_FILE = 12
Const OLE_INSERT_OBJ_DLG = 14
Const OLE_PASTE_SPECIAL_DLG = 15
Const OLE_FETCH_VERBS = 17
Const OLE_SAVE_TO_OLE1FILE = 18

'OLEType
Const OLE_LINKED = 0
Const OLE_EMBEDDED = 1
Const OLE_NONE = 3

'OLETypeAllowed
Const OLE_EITHER = 2

'UpdateOptions
Const OLE_AUTOMATIC = 0
Const OLE_FROZEN = 1
Const OLE_MANUAL = 2

'AutoActivate modes
Const OLE_ACTIVATE_MANUAL = 0
Const OLE_ACTIVATE_GETFOCUS = 1
Const OLE_ACTIVATE_DOUBLECLICK = 2

'SizeModes
Const OLE_SIZE_CLIP = 0
Const OLE_SIZE_STRETCH = 1
Const OLE_SIZE_AUTOSIZE = 2

'DisplayTypes
Const OLE_DISPLAY_CONTENT = 0
Const OLE_DISPLAY_ICON = 1

'Update Event Constants
Const OLE_CHANGED = 0
Const OLE_SAVED = 1
Const OLE_CLOSED = 2
Const OLE_RENAMED = 3

'Special Verb Values
Const VERB_PRIMARY = 0
Const VERB_SHOW = -1
Const VERB_OPEN = -2
Const VERB_HIDE = -3

'VerbFlag Bit Masks
Const VF_GRAYED = &H1
Const VF_DISABLED = &H2
Const VF_CHECKED = &H8
Const VF_SEPARATOR = &H800

Sub cmdAction_Click ()
    fraOptions.Enabled = True
    
    'Since the necessary code to activate the first quadrant
    'exists in one of the options buttons, simulate the user
    'clicking on View Quadrant 1
    optQuadrant(1).Value = True
    
    cmdAction.Enabled = False
    label1.Caption = "A linked OLE Object"
End Sub

Sub cmdClass_Click ()
    ole1.Class = "ExcelWorksheet"
    cmdSource.Enabled = True
    cmdclass.Enabled = False
End Sub

Sub cmdEnd_Click ()
    Unload frmOLE3
End Sub

Sub cmdSource_Click ()
    ole1.SourceDoc = "c:\vbdemos\ole\quad4.xls"
    ole1.SourceItem = "R1C3:R2C4"
    cmdAction.Enabled = True
    cmdSource.Enabled = False
End Sub

Sub optQuadrant_click (index As Integer)
    Select Case index
        Case 1
            ole1.SourceItem = "R1C3:R2C4"
        Case 2
            ole1.SourceItem = "R1C1:R2C2"
        Case 3
            ole1.SourceItem = "R3C1:R4C2"
        Case 4
            ole1.SourceItem = "R3C3:R4C4"
    End Select
    ole1.Action = OLE_CREATE_LINK
End Sub

