VERSION 2.00
Begin Form frmOLE4 
   AutoRedraw      =   -1  'True
   Caption         =   "OLE Automation Server"
   ClientHeight    =   4515
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   7365
   Height          =   4920
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   4515
   ScaleWidth      =   7365
   Top             =   1140
   Width           =   7485
   Begin CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   495
      Left            =   5040
      TabIndex        =   10
      Top             =   1440
      Width           =   1455
   End
   Begin ComboBox cboOperation 
      Height          =   300
      Left            =   1920
      Style           =   2  'Dropdown List
      TabIndex        =   9
      Top             =   480
      Width           =   615
   End
   Begin CommandButton cmdEvaluate 
      Caption         =   "Evaluate"
      Enabled         =   0   'False
      Height          =   495
      Left            =   2760
      TabIndex        =   8
      Top             =   1440
      Width           =   1455
   End
   Begin TextBox txtOperand 
      Enabled         =   0   'False
      Height          =   375
      Left            =   3120
      TabIndex        =   2
      Top             =   480
      Width           =   1455
   End
   Begin TextBox txtAccumulator 
      Enabled         =   0   'False
      Height          =   375
      Left            =   360
      TabIndex        =   1
      Top             =   480
      Width           =   1095
   End
   Begin CommandButton cmdLoad 
      Caption         =   "Load Server"
      Height          =   495
      Left            =   360
      TabIndex        =   0
      Top             =   1440
      Width           =   1575
   End
   Begin Label lblInstructions 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Place a number in the Accumulator and a number in the Operand. Next, select a mathematical operation. Then, click on Evaluate."
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   12
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   1095
      Left            =   360
      TabIndex        =   7
      Top             =   2400
      Visible         =   0   'False
      Width           =   6135
   End
   Begin Label lblResult 
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Left            =   5400
      TabIndex        =   6
      Top             =   480
      Width           =   1095
   End
   Begin Label lblEqual 
      Alignment       =   2  'Center
      Caption         =   "="
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   13.5
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   255
      Left            =   4800
      TabIndex        =   5
      Top             =   480
      Width           =   495
   End
   Begin Label lblOperand 
      Caption         =   "Operand"
      Height          =   255
      Left            =   3120
      TabIndex        =   4
      Top             =   240
      Width           =   975
   End
   Begin Label lblAccumulator 
      Caption         =   "Accumulator"
      Height          =   255
      Left            =   360
      TabIndex        =   3
      Top             =   240
      Width           =   1215
   End
End
Option Explicit

Dim autoserver As object

Sub cmdEnd_Click ()
    Unload frmOLE4
End Sub

Sub cmdEvaluate_Click ()
    'Set the op property of the remote object.
    autoserver.op = cboOperation.ListIndex + 1

    'Set 2 properties of the remote object.
    autoserver.Accum = Val(txtAccumulator.Text)
    autoserver.Opnd = Val(txtOperand.Text)
    
    'Invoke 2 methods of the remote object.
    autoserver.eval
    autoserver.display

    'Display the answer
    lblResult.Caption = Str$(autoserver.Accum)
End Sub

Sub cmdLoad_Click ()
    Set autoserver = CreateObject("dispcalc.ccalc")
    
    cmdLoad.Enabled = False
    cmdEvaluate.Enabled = True
    lblInstructions.Visible = True
    txtAccumulator.Enabled = True
    txtOperand.Enabled = True
End Sub

Sub Form_Load ()
    frmOLE4.Left = .27 * screen.Width
    frmOLE4.Width = .7 * screen.Width
    frmOLE4.Height = .67 * screen.Height
    frmOLE4.Top = .3 * screen.Height

    cboOperation.AddItem "+"
    cboOperation.AddItem "-"
    cboOperation.AddItem "*"
    cboOperation.AddItem "/"
    cboOperation.ListIndex = 0
End Sub

Sub Form_Unload (Cancel As Integer)
    On Error Resume Next
    
    'Shut down the remote object's application.
    autoserver.quit
End Sub

