VERSION 2.00
Begin MDIForm frmMDIParent 
   Caption         =   "MDI Parent"
   ClientHeight    =   1935
   ClientLeft      =   1110
   ClientTop       =   1740
   ClientWidth     =   5985
   Height          =   2625
   Left            =   1050
   LinkTopic       =   "MDIForm1"
   ScrollBars      =   0   'False
   Top             =   1110
   Width           =   6105
   Begin PictureBox Picture1 
      Align           =   1  'Align Top
      Height          =   740
      Left            =   0
      ScaleHeight     =   705
      ScaleWidth      =   5955
      TabIndex        =   0
      Top             =   0
      Width           =   5985
      Begin CommonDialog CMDialog1 
         Left            =   5400
         Top             =   0
      End
      Begin Image imgToolbar 
         Height          =   640
         Index           =   2
         Left            =   1080
         Picture         =   MDIPARNT.FRX:0000
         Stretch         =   -1  'True
         Top             =   0
         Width           =   480
      End
      Begin Image imgToolbar 
         Height          =   640
         Index           =   1
         Left            =   120
         Picture         =   MDIPARNT.FRX:0302
         Stretch         =   -1  'True
         Top             =   0
         Width           =   480
      End
   End
   Begin Menu mnuFile 
      Caption         =   "&File"
      Begin Menu mnuFileNew 
         Caption         =   "&New Child"
      End
      Begin Menu mnuFileOpen 
         Caption         =   "&Open File"
      End
      Begin Menu mnuFileSep1 
         Caption         =   "-"
      End
      Begin Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin Menu mnuHelp 
      Caption         =   "&Help"
      Begin Menu mnuHelpAbout 
         Caption         =   "&About MPBE Container"
      End
   End
End
Option Explicit

Sub imgToolbar_Click (index As Integer)
    Dim fname As String
    
    Select Case index
        Case 1
            fname = GetFileName()
            If fname = "" Then
                Exit Sub
            End If
            CreateNewEditor fname
        Case 2
            'This icon should be disabled if just the parent is showing.
            'The easiest way to do this is to determine if there
            'are any children.
            If TypeOf screen.ActiveForm Is frmMDIChild Then
                SaveCurrentEditor NO_QUERY
            End If
    End Select

End Sub

Sub MDIForm_Load ()
    Const DELTA = 750
    Const TOOLCOUNT = 2

    Dim tbMax As Integer
    Dim i As Integer

    'Make the MDI parent as large as possible.
    frmMDIParent.WindowState = MAXIMIZED
    
    tbMax = imgToolbar(1).Height
    imgToolbar(1).Left = 100
    imgToolbar(1).Top = 0

    For i = 2 To TOOLCOUNT
        If imgToolbar(i).Height > tbMax Then
            tbMax = imgToolbar(i).Height
        End If
        imgToolbar(i).Top = 0
        imgToolbar(i).Left = imgToolbar(i - 1).Left + DELTA
    Next i

    picture1.Height = tbMax
End Sub

Sub mnuFileExit_Click ()
    End
End Sub

Sub mnuFileNew_Click ()
    CreateNewEditor ""
End Sub

Sub mnuFileOpen_Click ()
    Dim fname As String

    fname = GetFileName()
    If fname = "" Then
        Exit Sub
    End If

    CreateNewEditor fname

End Sub

Sub mnuHelpAbout_Click ()
    MsgBox "You're looking at an empty MDI parent."
End Sub

