VERSION 2.00
Begin Form Form1 
   Caption         =   "Data6: Add"
   ClientHeight    =   4155
   ClientLeft      =   1095
   ClientTop       =   1575
   ClientWidth     =   7020
   Height          =   4560
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   4155
   ScaleWidth      =   7020
   Top             =   1230
   Width           =   7140
   Begin CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   375
      Left            =   5640
      TabIndex        =   13
      Top             =   2520
      Width           =   1095
   End
   Begin TextBox txtID 
      DataField       =   "Employee ID"
      DataSource      =   "Data1"
      Height          =   285
      Left            =   600
      TabIndex        =   0
      Top             =   360
      Width           =   1335
   End
   Begin CommandButton cmdAdd 
      Caption         =   "Add"
      Height          =   375
      Left            =   4200
      TabIndex        =   9
      Top             =   1320
      Width           =   1095
   End
   Begin CommandButton cmdUpdate 
      Caption         =   "Update"
      Height          =   375
      Left            =   4200
      TabIndex        =   8
      Top             =   720
      Width           =   1100
   End
   Begin CommandButton cmdFind 
      Caption         =   "Find"
      Height          =   375
      Left            =   4200
      TabIndex        =   7
      Top             =   120
      Width           =   1100
   End
   Begin CommandButton cmdLast 
      Caption         =   "Last"
      Height          =   375
      Left            =   5640
      TabIndex        =   6
      Top             =   1920
      Width           =   1100
   End
   Begin CommandButton cmdFirst 
      Caption         =   "First"
      Height          =   375
      Left            =   5640
      TabIndex        =   5
      Top             =   1320
      Width           =   1100
   End
   Begin CommandButton cmdPrior 
      Caption         =   "Prior"
      Height          =   375
      Left            =   5640
      TabIndex        =   4
      Top             =   720
      Width           =   1100
   End
   Begin CommandButton cmdNext 
      Caption         =   "Next"
      Height          =   375
      Left            =   5640
      TabIndex        =   3
      Top             =   120
      Width           =   1100
   End
   Begin TextBox txtFirstName 
      DataField       =   "First Name"
      DataSource      =   "Data1"
      Height          =   375
      Left            =   600
      TabIndex        =   2
      Top             =   1920
      Width           =   3135
   End
   Begin TextBox txtLastName 
      DataField       =   "Last Name"
      DataSource      =   "Data1"
      Height          =   375
      Left            =   600
      TabIndex        =   1
      Top             =   1080
      Width           =   3135
   End
   Begin Data Data1 
      Caption         =   "Data1"
      Connect         =   ""
      DatabaseName    =   "C:\VBDEMOS\NWIND.MDB"
      Exclusive       =   0   'False
      Height          =   270
      Left            =   600
      Options         =   0
      ReadOnly        =   0   'False
      RecordSource    =   "Employees"
      Top             =   2640
      Width           =   3135
   End
   Begin Label lblID 
      Caption         =   "ID Number"
      Height          =   255
      Left            =   600
      TabIndex        =   12
      Top             =   120
      Width           =   1095
   End
   Begin Label lblFirstName 
      Caption         =   "First Name"
      Height          =   255
      Left            =   600
      TabIndex        =   11
      Top             =   1680
      Width           =   1335
   End
   Begin Label lblLastName 
      Caption         =   "Last Name"
      Height          =   255
      Left            =   600
      TabIndex        =   10
      Top             =   840
      Width           =   975
   End
End
Option Explicit

Const SIZE = 11

Dim MyCommands(SIZE) As commandbutton


Dim sQuote As String
Dim src As String
Dim criteria As String
Dim currentRecord As String

Sub cmdAdd_Click ()
    Data1.Recordset.AddNew
    txtId.SetFocus
End Sub

Sub cmdEnd_Click ()
    Unload form1
End Sub

Sub cmdFind_Click ()
    sQuote = Chr$(34)

    'Save the current position.
    currentRecord = Data1.Recordset.Bookmark

    src = InputBox$("Enter last name of employee to find", "Find Box")
    If src = "" Then Exit Sub
    
    criteria = "[Last Name] = " & sQuote & src & sQuote
    Data1.Recordset.FindFirst criteria
    
    If Data1.Recordset.NoMatch Then
        MsgBox "No Record Found!", , "What were you thinking?"
        Data1.Recordset.Bookmark = currentRecord
    Else
        cmdNext.Enabled = True
        cmdPrior.Enabled = True
    End If
End Sub

Sub cmdFirst_Click ()
    Data1.Recordset.MoveFirst
    cmdNext.Enabled = True
    cmdPrior.Enabled = False
End Sub

Sub cmdLast_Click ()
    Data1.Recordset.MoveLast
    cmdPrior.Enabled = True
    cmdNext.Enabled = False
End Sub

Sub cmdNext_Click ()
    Data1.Recordset.MoveNext
    cmdPrior.Enabled = True
    
    If Data1.Recordset.EOF Then
        Data1.Recordset.MoveLast
        cmdNext.Enabled = False
    End If

End Sub

Sub cmdPrior_Click ()
    
    Data1.Recordset.MovePrevious
    cmdNext.Enabled = True
    If Data1.Recordset.BOF Then
        Data1.Recordset.MoveFirst
        cmdPrior.Enabled = False
    End If

End Sub

Sub cmdUpdate_Click ()
    Data1.Recordset.Update
End Sub

Sub Form_Load ()
    'Stuff the command buttons into an array for easier processing.
    Set MyCommands(2) = cmdNext
    Set MyCommands(3) = cmdPrior
    Set MyCommands(4) = cmdFirst
    Set MyCommands(5) = cmdLast
    Set MyCommands(6) = cmdFind
    Set MyCommands(7) = cmdUpdate
    Set MyCommands(8) = cmdAdd


End Sub

Sub ReEnableButtons ()
    Dim I As Integer
    cmdAdd.Visible = True
    
    'Re-enable all the buttons.
    For I = 2 To 7
        MyCommands(I).Enabled = True
    Next I
End Sub

