VERSION 2.00
Begin Form Form1 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Finding Records"
   ClientHeight    =   4725
   ClientLeft      =   1095
   ClientTop       =   1110
   ClientWidth     =   4845
   Height          =   5130
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   4725
   ScaleWidth      =   4845
   Top             =   765
   Width           =   4965
   Begin SSPanel pnlStatus 
      Align           =   2  'Align Bottom
      Alignment       =   1  'Left Justify - MIDDLE
      BackColor       =   &H00C0C0C0&
      BevelInner      =   1  'Inset
      BevelOuter      =   0  'None
      Font3D          =   0  'None
      Height          =   495
      Left            =   0
      TabIndex        =   13
      Top             =   4230
      Width           =   4845
   End
   Begin SSPanel Panel3D1 
      BackColor       =   &H00C0C0C0&
      BevelInner      =   2  'Raised
      BevelOuter      =   1  'Inset
      Font3D          =   0  'None
      Height          =   735
      Left            =   0
      TabIndex        =   12
      Top             =   0
      Width           =   6975
      Begin Image Image2 
         Height          =   480
         Left            =   1320
         Picture         =   FINDMAIN.FRX:0000
         Top             =   120
         Width           =   480
      End
      Begin Image Image1 
         Height          =   480
         Left            =   435
         Picture         =   FINDMAIN.FRX:0302
         Top             =   105
         Width           =   480
      End
   End
   Begin CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   375
      Left            =   3660
      TabIndex        =   11
      Top             =   3840
      Width           =   1095
   End
   Begin TextBox txtID 
      BackColor       =   &H00E0E0E0&
      DataField       =   "Employee ID"
      DataSource      =   "Data1"
      Enabled         =   0   'False
      ForeColor       =   &H00000000&
      Height          =   285
      Left            =   225
      TabIndex        =   0
      Top             =   1125
      Width           =   1335
   End
   Begin CommandButton cmdDelete 
      Caption         =   "Delete"
      Height          =   375
      Left            =   3660
      TabIndex        =   7
      Top             =   2040
      Width           =   1095
   End
   Begin CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3660
      TabIndex        =   6
      Top             =   3240
      Width           =   1095
   End
   Begin CommandButton cmdSave 
      Caption         =   "Save"
      Height          =   375
      Left            =   3660
      TabIndex        =   5
      Top             =   2640
      Width           =   1095
   End
   Begin CommandButton cmdAdd 
      Caption         =   "Add"
      Height          =   375
      Left            =   3660
      TabIndex        =   4
      Top             =   840
      Width           =   1095
   End
   Begin CommandButton cmdUpdate 
      Caption         =   "Update"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3660
      TabIndex        =   3
      Top             =   1440
      Width           =   1100
   End
   Begin TextBox txtFirstName 
      DataField       =   "First Name"
      DataSource      =   "Data1"
      Height          =   375
      Left            =   225
      TabIndex        =   2
      Top             =   2685
      Width           =   3135
   End
   Begin TextBox txtLastName 
      DataField       =   "Last Name"
      DataSource      =   "Data1"
      Height          =   375
      Left            =   225
      TabIndex        =   1
      Top             =   1845
      Width           =   3135
   End
   Begin Data Data1 
      Caption         =   "Data1"
      Connect         =   ""
      DatabaseName    =   "C:\VBDEMOS\NWIND.MDB"
      Exclusive       =   0   'False
      Height          =   270
      Left            =   255
      Options         =   0
      ReadOnly        =   0   'False
      RecordSource    =   "Employees"
      Top             =   3270
      Width           =   3135
   End
   Begin Label lblID 
      BackColor       =   &H00C0C0C0&
      Caption         =   "ID Number"
      Height          =   285
      Left            =   225
      TabIndex        =   10
      Top             =   885
      Width           =   1335
   End
   Begin Label lblFirstName 
      BackColor       =   &H00C0C0C0&
      Caption         =   "First Name"
      Height          =   255
      Left            =   225
      TabIndex        =   9
      Top             =   2445
      Width           =   1335
   End
   Begin Label lblLastName 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Last Name"
      Height          =   255
      Left            =   225
      TabIndex        =   8
      Top             =   1605
      Width           =   975
   End
End
Option Explicit
Const WHITE = &HFFFFFF
Const GREY = &HE0E0E0

Const SIZE = 11

Const ERROR_MSG = "You have entered an Employee ID that already exists. Modify Employee ID before proceeding."

Const KEY_DELETE = &H2E

Sub cmdadd_click ()
    On Error GoTo AddErr
    currentrecord = data1.Recordset.Bookmark

    data1.Recordset.AddNew
    
    'Enable Save and Cancel - Disable Delete
    cmdSave.Enabled = True
    cmdCancel.Enabled = True
    cmdDelete.Enabled = False
    
    'Enable ID field for Add
    txtId.Enabled = True
    txtId.BackColor = WHITE
    txtId.SetFocus
endadd:
    Exit Sub

AddErr:
    If Err = 3022 Then
        MsgBox "You have entered a duplicate Employee ID - Modify Employee ID"
        txtId.SelStart = 0
        txtId.SelLength = Len(txtId.Text)
        txtId.SetFocus
        Resume endadd
    Else
        MsgBox Error$ & Str$(Err)
        End
    End If

End Sub

Sub cmdCancel_Click ()
    
    'Restore position to where you were
    'when you started Adding records
     data1.Recordset.Bookmark = currentrecord

    'Reset buttons to show leaving Add mode
    ReSetButtons

    'Disable ID field
    txtId.Enabled = False
    txtId.BackColor = GREY
    txtLastName.SetFocus
End Sub

Sub cmdDelete_Click ()
    On Error Resume Next

    data1.Recordset.Delete
    data1.Recordset.MoveNext
    
    'If the last record was just deleted, move to the
    'new last record
    If data1.Recordset.EOF Then
        data1.Recordset.MoveLast
    End If
End Sub

Sub cmdEnd_Click ()
    Unload form1
    Unload Form2
End Sub

Sub cmdSave_Click ()
    On Error GoTo SaveError

    data1.UpdateRecord

    
    'Reset buttons to show leaving Add mode
    ReSetButtons
    
    'Disable ID field
    txtId.Enabled = False
    txtId.BackColor = GREY
    txtLastName.SetFocus
TerminateSave:
    Exit Sub

SaveError:
    If Err = 3022 Then
        MsgBox ERROR_MSG
        txtId.SelStart = 0
        txtId.SelLength = Len(txtId.Text)
        txtId.SetFocus
    Else
        MsgBox Error$
    End If

    Resume TerminateSave

End Sub

Sub cmdUpdate_Click ()
    
    'Invoke Data1.UpdateRecord rather
    'than Data1.RecordSet.Update.
    'Data1.UpdateRecord saves a record
    'but DOES NOT invoke Validation Event.
    'We don't want to prompt user to save
    'if he or she explicitly chose Update.

    data1.UpdateRecord
    cmdUpdate.Enabled = False
End Sub

Sub Data1_Error (DataErr As Integer, response As Integer)
    Const CONTINUE = 0

    If DataErr = 3022 Then
        MsgBox ERROR_MSG
        txtId.SelStart = 0
        txtId.SelLength = Len(txtId.Text)
        txtId.SetFocus
        response = CONTINUE
    End If
End Sub

Sub Data1_Reposition ()
    cmdUpdate.Enabled = False
    'Disable ID field
    txtId.Enabled = False
    txtId.BackColor = GREY
    'txtLastName.SetFocus

End Sub

Sub Data1_Validate (Action As Integer, Save As Integer)
    Const IDNO = 7
    
    If Save = True Then
        'We will prompt the user to save record
        'for all actions EXCEPT ADD.

        'If the user selected ADD then ADD again,
        'we do not want to issue prompt. (Ation 5 is Add)
        'However, if Update button is visible, that
        'means the user user modified a record
        'but has not saved it yet.
        'In this case, we should issue prompt.
        If Action <> 5 Or cmdUpdate.Enabled = True Then 'prompt on AddNew
          If MsgBox("save?", 4) = IDNO Then
              Save = False
              data1.UpdateControls
          End If
        End If
    End If
    
    If Action <> 5 Then
        'Reset Buttons to show leaving Add mode
         ReSetButtons
    End If

End Sub

Sub Form_Activate ()
    pnlStatus.Caption = ""
End Sub

Sub Form_Load ()

    'make Save and Cancel invisible
    cmdSave.Enabled = False
    cmdCancel.Enabled = False
End Sub

Sub Image1_Click ()
    Form2.Show
End Sub

Sub Image1_MouseMove (Button As Integer, Shift As Integer, X As Single, Y As Single)
    pnlStatus.Caption = "Click on Binoculars for Search"
End Sub

Sub Image2_Click ()
    cmdadd_click
End Sub

Sub Image2_MouseMove (Button As Integer, Shift As Integer, X As Single, Y As Single)
    pnlStatus.Caption = "Click cardfile to add a new record."
End Sub

Sub Panel3D1_MouseMove (Button As Integer, Shift As Integer, X As Single, Y As Single)
    pnlStatus.Caption = ""
End Sub

Sub ReSetButtons ()
    'ReEnableButtons is called whenever you Cancel
    'or save a record. It simply hides Save and Cancel
    'to show you are no longer in Add mode
    'and reenables Delete. (Delete is only valid
    'if you are not in Add mode.)

    'This routine is invoked from cmdSave, cmdCancel,
    'cmdFind and the Validation Event of data control
    cmdSave.Enabled = False
    cmdCancel.Enabled = False
    cmdDelete.Enabled = True

End Sub

Sub txtFirstName_KeyPress (KeyAscii As Integer)
    If cmdSave.Visible = False Then
        cmdUpdate.Enabled = True
    End If
End Sub

Sub txtLastName_KeyDown (KeyCode As Integer, Shift As Integer)
    If KeyCode = KEY_DELETE And cmdSave.Enabled = False Then
        cmdUpdate.Enabled = True
    End If

End Sub

Sub txtLastName_KeyPress (KeyAscii As Integer)
'If you are in Add mode - you would not
'enabled Update button.
'Check cmdSave to see if you are in Add mode.
    If cmdSave.Enabled = False Then
        cmdUpdate.Enabled = True
    End If
End Sub

