VERSION 2.00
Begin Form Form1 
   Caption         =   "Locking: Optimistic vs. Pessimistic"
   ClientHeight    =   5865
   ClientLeft      =   1650
   ClientTop       =   1350
   ClientWidth     =   4785
   Height          =   6270
   Left            =   1590
   LinkTopic       =   "Form1"
   ScaleHeight     =   5865
   ScaleWidth      =   4785
   Top             =   1005
   Width           =   4905
   Begin CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3240
      TabIndex        =   16
      Top             =   3240
      Width           =   1095
   End
   Begin Data Data1 
      Caption         =   "Data1"
      Connect         =   ""
      DatabaseName    =   "C:\VBDEMOS\NWIND.MDB"
      Exclusive       =   0   'False
      Height          =   270
      Left            =   240
      Options         =   0
      ReadOnly        =   0   'False
      RecordSource    =   "Orders"
      Top             =   3120
      Width           =   2655
   End
   Begin Frame frmLockOptions 
      Caption         =   "Locking Options"
      Height          =   1335
      Left            =   240
      TabIndex        =   12
      Top             =   3600
      Width           =   2655
      Begin OptionButton optOptimistic 
         Caption         =   "Optimistic Locking"
         Height          =   255
         Left            =   240
         TabIndex        =   14
         Top             =   840
         Width           =   2055
      End
      Begin OptionButton optPessimistic 
         Caption         =   "Pessimistic Locking"
         Height          =   255
         Left            =   240
         TabIndex        =   13
         Top             =   360
         Width           =   2295
      End
   End
   Begin CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   375
      Left            =   3240
      TabIndex        =   11
      Top             =   4560
      Width           =   1095
   End
   Begin CommandButton cmdUpdate 
      Caption         =   "Update"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3240
      TabIndex        =   10
      Top             =   2640
      Width           =   1095
   End
   Begin TextBox txtID 
      BackColor       =   &H00FFFFFF&
      DataField       =   "Order ID"
      DataSource      =   "Data1"
      Enabled         =   0   'False
      ForeColor       =   &H00000000&
      Height          =   285
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   1335
   End
   Begin CommandButton cmdLast 
      Caption         =   "Last"
      Height          =   375
      Left            =   3240
      TabIndex        =   6
      Top             =   2040
      Width           =   1100
   End
   Begin CommandButton cmdFirst 
      Caption         =   "First"
      Height          =   375
      Left            =   3240
      TabIndex        =   5
      Top             =   1440
      Width           =   1100
   End
   Begin CommandButton cmdPrevious 
      Caption         =   "Previous"
      Height          =   375
      Left            =   3240
      TabIndex        =   4
      Top             =   840
      Width           =   1100
   End
   Begin CommandButton cmdNext 
      Caption         =   "Next"
      Height          =   375
      Left            =   3240
      TabIndex        =   3
      Top             =   240
      Width           =   1100
   End
   Begin TextBox txtShipAddress 
      DataField       =   "Ship Address"
      DataSource      =   "Data1"
      Height          =   855
      Left            =   240
      MultiLine       =   -1  'True
      TabIndex        =   2
      Top             =   1920
      Width           =   2655
   End
   Begin TextBox txtShipName 
      DataField       =   "Ship Name"
      DataSource      =   "Data1"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   1080
      Width           =   2655
   End
   Begin Label lblLockStatus 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "You've Got the Page Locked"
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   13.5
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   495
      Left            =   240
      TabIndex        =   15
      Top             =   5160
      Visible         =   0   'False
      Width           =   4335
   End
   Begin Label lblID 
      Caption         =   "Order ID"
      Height          =   255
      Left            =   240
      TabIndex        =   9
      Top             =   120
      Width           =   1095
   End
   Begin Label lblFirstName 
      Caption         =   "Ship Address"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   1680
      Width           =   1335
   End
   Begin Label lblLastName 
      Caption         =   "Ship Name"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   840
      Width           =   975
   End
End
Option Explicit

Dim cancelupdate As Integer
Const ERROR_MSG = "You have entered an Employee ID that already exists. Modify Employee ID before proceeding."

Const KEY_DELETE = &H2E

' MsgBox return values
Const IDOK = 1                  ' OK button pressed
Const IDCANCEL = 2              ' Cancel button pressed
Const IDABORT = 3               ' Abort button pressed
Const IDRETRY = 4               ' Retry button pressed
Const IDIGNORE = 5              ' Ignore button pressed
Const IDYES = 6                 ' Yes button pressed
Const IDNO = 7                  ' No button pressed

Sub cmdCancel_Click ()

    'UpdateControls brings up correct data.
    'However, you must still execute Update
    'or move to get lock off.
    'Since we don't want to move off record we
    'force an update and indicate NoSave
    data1.UpdateControls
    cancelupdate = True
    data1.Recordset.Update
    
End Sub

Sub cmdEnd_Click ()
    Unload form1
End Sub

Sub cmdFirst_Click ()
    data1.Recordset.MoveFirst
End Sub

Sub cmdLast_Click ()
    data1.Recordset.MoveLast
End Sub

Sub cmdNext_Click ()
    On Error Resume Next
    
    data1.Recordset.MoveNext
    If data1.Recordset.EOF Then
        data1.Recordset.MoveLast
    End If
End Sub

Sub cmdPrevious_Click ()
    On Error Resume Next
    
    data1.Recordset.MovePrevious
    If data1.Recordset.BOF Then
        data1.Recordset.MoveFirst
    End If

End Sub

Sub cmdUpdate_Click ()
    Dim rc As Integer, i As Integer
    On Error GoTo updateerror

    data1.Recordset.Update
    lblLockStatus.Visible = False

    cmdUpdate.Enabled = False

terminatesub:
    Exit Sub

updateerror:
    Select Case Err
        Case 3022
            MsgBox ERROR_MSG
            txtID.SelStart = 0
            txtID.SelLength = Len(txtID.Text)
            txtID.SetFocus
        Case 3197
            rc = MsgBox("Another process has changed the record since you began editing. Overwrite latest record?", 36, "What you gonna do?")
            If rc = 6 Then
                Resume
            Else
                Resume Next
            End If
        Case 3260
            MsgBox "Try Later", , "Record is locked."
        Case Else
            MsgBox Err & Error$
    End Select
    Resume terminatesub
End Sub

Sub Command1_Click ()
    
End Sub

Sub Data1_RePosition ()
    lblLockStatus.Visible = False
    cmdUpdate.Enabled = False
End Sub

Sub data1_validate (Action As Integer, save As Integer)

    If cancelupdate = True Then 'User chose CANCEL
        save = False
        data1.UpdateControls
        cancelupdate = False
        lblLockStatus.Visible = False
    End If

End Sub

Sub Form_Load ()

    If app.PrevInstance Then
        left = screen.Width / 2
    Else
        left = 0
    End If
    top = 0
    Width = screen.Width / 2
    data1.Refresh
    optPessimistic.Value = True
End Sub

Function LockingError (ThisErr As Integer) As Integer
    Dim rc As Integer
    
    Select Case ThisErr
        Case 3197
            rc = MsgBox("This record had been changed by another application. Refresh before proceeding with edits?", 36)
        Case 3260
            MsgBox "Another program has the current page locked. Try Later."
            rc = IDABORT
        Case Else
            MsgBox Err & " " & Error$
            End
    End Select

    LockingError = rc
End Function

Sub optOptimistic_Click ()
    data1.Recordset.LockEdits = False
End Sub

Sub optPessimistic_Click ()
    data1.Recordset.LockEdits = True
End Sub

Sub txtShipName_KeyDown (keycode As Integer, Shift As Integer)
    'The delete key is the only destructive key in KeyDown
    'Everything else is trapped in KeyPress.
    If keycode <> KEY_DELETE Then Exit Sub
    
    Dim rc As Integer
    On Error GoTo ShipNameError
    
    'This is the statement which causes a trappable error if the
    'table is locked.
    data1.Recordset.Edit
    
    lblLockStatus.Visible = (data1.Recordset.LockEdits = True)
    cmdUpdate.Enabled = True

TerminateShipNameChange:
    Exit Sub

ShipNameError:
    rc = LockingError(Err)
    Select Case rc
        Case IDABORT
            'Consume keystroke, exit.
            keycode = 0
            Resume TerminateShipNameChange
        Case IDYES
            'Update control, consume keystroke, exit.
            data1.UpdateControls
            keycode = 0
            Resume TerminateShipNameChange
        Case IDNO
            'Accept keystroke
            Resume Next
    End Select
End Sub

Sub txtShipName_KeyPress (keyascii As Integer)
    Dim rc As Integer
    On Error GoTo ShipNameError2
    
    'This is the statement which causes a trappable error if the
    'table is locked.
    data1.Recordset.Edit
    
    lblLockStatus.Visible = (data1.Recordset.LockEdits = True)
    cmdUpdate.Enabled = True

TerminateShipNameChange2:
    Exit Sub

ShipNameError2:
    rc = LockingError(Err)
    Select Case rc
        Case IDABORT
            'Consume keystroke, exit.
            keyascii = 0
            Resume TerminateShipNameChange2
        Case IDYES
            'Update control, consume keystroke, exit.
            data1.UpdateControls
            keyascii = 0
            Resume TerminateShipNameChange2
        Case IDNO
            'Accept keystroke
            Resume Next
    End Select
End Sub

