VERSION 2.00
Begin Form frmActQuery 
   Caption         =   "Action Query: Update Price by 10% "
   ClientHeight    =   5190
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   7365
   Height          =   5595
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   5190
   ScaleWidth      =   7365
   Top             =   1140
   Width           =   7485
   Begin CommandButton cmdExecute 
      Caption         =   "Update Prices"
      Enabled         =   0   'False
      Height          =   495
      Left            =   4560
      TabIndex        =   3
      Top             =   4440
      Width           =   2295
   End
   Begin CommandButton cmdCreateQuery 
      Caption         =   "Create QueryDef"
      Enabled         =   0   'False
      Height          =   495
      Left            =   2160
      TabIndex        =   2
      Top             =   4440
      Width           =   2055
   End
   Begin Grid Grid1 
      Cols            =   3
      FixedCols       =   0
      Height          =   615
      Left            =   600
      TabIndex        =   1
      Top             =   360
      Visible         =   0   'False
      Width           =   1815
   End
   Begin CommandButton cmdLoad 
      Caption         =   "Load Database"
      Height          =   495
      Left            =   360
      TabIndex        =   0
      Top             =   4440
      Width           =   1455
   End
End
Option Explicit

Dim MYQUERY As querydef
Dim ds As dynaset
Dim db As database

Const QNAME = "updateprices"

Sub cmdCreateQuery_Click ()
    Dim sql As String

    On Error GoTo DataError
    
    sql = "update products set [unit price] = [unit price] * 1.10;"

    screen.MousePointer = 11
        Set MYQUERY = db.CreateQueryDef(QNAME, sql)
ExitcmdCreateQuery:
        cmdExecute.Enabled = True
        cmdCreateQuery.Enabled = False
    screen.MousePointer = 0
    
    Exit Sub

DataError:
    If Err = 3012 Then
        Set MYQUERY = db.OpenQueryDef("UpdatePrices")
        Resume ExitcmdCreateQuery
    Else
        MsgBox Err & " " & Error$
        End
    End If
End Sub

Sub cmdExecute_Click ()
    screen.MousePointer = 11
        MYQUERY.Execute
        Set ds = ds.CreateDynaset()
        PlaceDataInGrid
    screen.MousePointer = 0
End Sub

Sub cmdLoad_Click ()
    screen.MousePointer = 11
        cmdLoad.Enabled = False
        Set db = OpenDatabase("c:\vbdemos\nwind.mdb")
        Set ds = db.CreateDynaset("products")
        PlaceDataInGrid
        cmdCreateQuery.Enabled = True
    screen.MousePointer = 0
End Sub

Sub Form_Unload (Cancel As Integer)
    On Error Resume Next
    db.DeleteQueryDef (QNAME)
End Sub

Sub PlaceDataInGrid ()
    grid1.Visible = False
    grid1.Width = 5500
    grid1.Height = 3800

    grid1.Row = 0
    
    grid1.Col = 0
    grid1.ColWidth(0) = 800
    grid1.Text = "Product ID"
    grid1.Col = 1
    grid1.ColWidth(1) = 2910
    grid1.Text = "Product Name"
    grid1.Col = 2
    grid1.ColWidth(2) = 1485
    grid1.Text = "Unit Price"
    
    Do Until ds.EOF
       grid1.Row = grid1.Row + 1
       grid1.Col = 0
       grid1.Text = ds![Product ID]
       grid1.Col = 1
       grid1.Text = ds![Product Name]
       grid1.Col = 2
       grid1.Text = ds![Unit Price]
       grid1.Rows = grid1.Rows + 1
       ds.MoveNext
    Loop
    
    ds.MoveFirst
    grid1.Left = (form1.ScaleWidth - grid1.Width) / 2
    grid1.Visible = True
End Sub

