VERSION 2.00
Begin Form frmDBInfo 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Database Information"
   ClientHeight    =   4320
   ClientLeft      =   300
   ClientTop       =   1770
   ClientWidth     =   9270
   Height          =   5010
   Left            =   240
   LinkTopic       =   "Form1"
   ScaleHeight     =   4320
   ScaleWidth      =   9270
   Top             =   1140
   Width           =   9390
   Begin CommandButton cmdPrevious 
      Caption         =   "Previous"
      Height          =   375
      Left            =   7440
      TabIndex        =   12
      Top             =   3360
      Width           =   1095
   End
   Begin CommandButton cmdNext 
      Caption         =   "Next"
      Height          =   375
      Left            =   7440
      TabIndex        =   11
      Top             =   2880
      Width           =   1095
   End
   Begin CommonDialog CMDialog1 
      Left            =   6600
      Top             =   3600
   End
   Begin ListBox lstFldDetails 
      Height          =   1200
      Left            =   7080
      TabIndex        =   9
      Top             =   1560
      Width           =   1935
   End
   Begin ListBox lstKeyNames 
      Height          =   1200
      Left            =   2760
      TabIndex        =   3
      Top             =   1560
      Width           =   1935
   End
   Begin ListBox lstFieldNames 
      Height          =   1200
      Left            =   4920
      TabIndex        =   1
      Top             =   1560
      Width           =   1935
   End
   Begin ListBox lstTableNames 
      Height          =   1200
      Left            =   480
      TabIndex        =   0
      Top             =   1560
      Width           =   2055
   End
   Begin Label Label7 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Click Field Name for details"
      Height          =   375
      Left            =   4920
      TabIndex        =   10
      Top             =   2880
      Width           =   1695
   End
   Begin Label Label6 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Field Details"
      Height          =   255
      Left            =   7080
      TabIndex        =   8
      Top             =   1200
      Width           =   1095
   End
   Begin Label Label5 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Click Table Name for details."
      Height          =   495
      Left            =   480
      TabIndex        =   7
      Top             =   2880
      Width           =   1935
   End
   Begin Label Label4 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Indexes"
      Height          =   255
      Left            =   2760
      TabIndex        =   6
      Top             =   1200
      Width           =   735
   End
   Begin Label Label3 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Fields"
      Height          =   255
      Left            =   4920
      TabIndex        =   5
      Top             =   1200
      Width           =   615
   End
   Begin Label Label2 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Tables"
      Height          =   255
      Left            =   480
      TabIndex        =   4
      Top             =   1200
      Width           =   615
   End
   Begin Label Label1 
      Alignment       =   2  'Center
      BackColor       =   &H00C0C0C0&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "This application displays information about a database."
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   615
      Left            =   2160
      TabIndex        =   2
      Top             =   240
      Width           =   4455
   End
   Begin Menu mnuFile 
      Caption         =   "File"
      Begin Menu mnuFileOpen 
         Caption         =   "Open Database"
      End
      Begin Menu mnuFileExit 
         Caption         =   "Exit"
      End
   End
End
Dim sCurTable As String
Dim sCurField As String
Dim db As Database
Dim ds As Dynaset
Dim td As tabledef

Dim snp As snapshot
Dim tb As Table
Const DB_SYSTEMOBJECT = &H80000002

Sub cmdGetTables_Click ()
    'This routine fills list box with list of tables from database
    Dim iTmp As Integer
    
    lstTableNames.Clear
    For iTmp = 0 To db.TableDefs.Count - 1
        If (db.TableDefs(iTmp).Attributes And DB_SYSTEMOBJECT) = 0 Then
            lstTableNames.AddItem db.TableDefs(iTmp).Name
        End If
    Next iTmp
End Sub

Sub cmdNext_Click ()
    On Error Resume Next
    ds.MoveNext
    If ds.EOF Then ds.MoveLast
    GetfieldDetails
End Sub

Sub cmdPrevious_Click ()
    On Error Resume Next
    ds.MovePrevious
    If ds.BOF Then ds.MoveFirst
    GetfieldDetails
End Sub

Sub Form_Unload (Cancel As Integer)
    On Error Resume Next
    ds.Close
    Set ds = Nothing
    snp.Close
    Set snp = Nothing
    tb.Close
    Set tb = Nothing
    db.Close
    Set db = Nothing
    End
End Sub

Sub GetfieldDetails ()
    On Error Resume Next
    'This routine fills the lstFieldDetails list box
    'with information about the field that is currently
    'selected in the Fields list box.

    Dim sItem As String
    Dim iField As Integer

    lstFldDetails.Clear
    iField = lstFieldNames.ListIndex 'Currently selected field
    sItem = "Value = "
    sItem = sItem + ds.Fields(iField).Value
    lstFldDetails.AddItem sItem

    sItem = "Type = "
    sItem = sItem + ds.Fields(iField).Type
    lstFldDetails.AddItem sItem


    sItem = "Size = "
    sItem = sItem + ds.Fields(iField).Size
    lstFldDetails.AddItem sItem
End Sub

Sub GetFields ()
    'This routine places field names from selected table
    'into list box. Invoked from lstTableNames_Click
    
    Dim iTmp As Integer
    lstFieldNames.Clear

    For iTmp = 0 To ds.Fields.Count - 1
      lstFieldNames.AddItem ds.Fields(iTmp).Name
    Next iTmp
End Sub

Sub GetKeys ()
    'This routine fills a list box with the names of the indexes
    'on the table selected in the table list box.
    Dim tmpMatch As Integer
    Dim tmp As Integer

    lstKeyNames.Clear
    
    'Open a table, then create a snapshot of its indexes.
    Set tb = db.OpenTable(sCurTable)
    Set snp = tb.ListIndexes()
    
    Do Until snp.EOF
      'scan list box to be sure index has not already
      'been added - This is necessary because some
      'indexes are based on two or more columns.
      'Those indexes would appear once for each
      'column. We only want them once in the list box.
      tmpMatch = False
      For tmp = 0 To lstKeyNames.ListCount - 1
        If lstKeyNames.List(tmp) = snp!IndexName Then
            tmpMatch = True
        End If
      Next tmp
      If Not tmpMatch Then
        lstKeyNames.AddItem snp!IndexName
      End If
      snp.MoveNext
    Loop
End Sub

Sub lstFieldNames_Click ()
    'When you click the lstFieldNames list box you set
    'lstFieldNames.ListIndex. That will indicate a particular
    'field that can be used in the GetFieldDetails routine
    'to fill the details list box.
    GetfieldDetails
End Sub

Sub lstTableNames_Click ()
    'This routine places field names from selected table
    'into field name list box.
    'And places keys from selected table into key list box
    sCurTable = lstTableNames.List(lstTableNames.ListIndex)
    Set ds = db.CreateDynaset(sCurTable)
    
    lstFldDetails.Clear
    GetFields
    GetKeys
End Sub

Sub mnuFileExit_Click ()
    Unload form1
End Sub

Sub mnuFileOpen_Click ()
    'Prompt for a database Name and open database

    'Clear out any previous information
    lstTableNames.Clear
    lstKeyNames.Clear
    lstFieldNames.Clear
    lstFldDetails.Clear

    cmdialog1.Filter = "Database Files (*.mdb)|*.mdb|All Files (*.*)|*.*"
    cmdialog1.Action = 1
    Set db = OpenDatabase(cmdialog1.Filename)

    cmdGetTables_Click

End Sub

