VERSION 2.00
Begin Form frmFilter 
   Caption         =   "Object Variables: Filtering a Dynaset"
   ClientHeight    =   4455
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   6375
   Height          =   4860
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   4455
   ScaleWidth      =   6375
   Top             =   1140
   Width           =   6495
   Begin Frame frmFiltering 
      Caption         =   "Filtering Options"
      Enabled         =   0   'False
      Height          =   1215
      Left            =   600
      TabIndex        =   8
      Top             =   3000
      Width           =   5295
      Begin OptionButton optFilterFirst2 
         Caption         =   "First Names > M"
         Height          =   255
         Left            =   2760
         TabIndex        =   12
         Top             =   840
         Width           =   2415
      End
      Begin OptionButton optFilterFirst1 
         Caption         =   "First Names <= M"
         Height          =   255
         Left            =   2760
         TabIndex        =   11
         Top             =   360
         Width           =   2415
      End
      Begin OptionButton optFilterLast2 
         Caption         =   "Last Names > M"
         Height          =   255
         Left            =   240
         TabIndex        =   10
         Top             =   840
         Width           =   2295
      End
      Begin OptionButton optFilterLast1 
         Caption         =   "Last Names <= M"
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   360
         Width           =   2415
      End
   End
   Begin CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   375
      Left            =   600
      TabIndex        =   7
      Top             =   2400
      Width           =   1335
   End
   Begin CommandButton cmdLast 
      Caption         =   "Last"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4920
      TabIndex        =   6
      Top             =   2400
      Width           =   975
   End
   Begin CommandButton cmdFirst 
      Caption         =   "First"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4920
      TabIndex        =   5
      Top             =   1680
      Width           =   975
   End
   Begin CommandButton cmdPrevious 
      Caption         =   "Previous"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4920
      TabIndex        =   4
      Top             =   960
      Width           =   975
   End
   Begin CommandButton cmdNext 
      Caption         =   "Next"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4920
      TabIndex        =   3
      Top             =   240
      Width           =   975
   End
   Begin CommandButton cmdLoad 
      Caption         =   "Load Database"
      Height          =   375
      Left            =   600
      TabIndex        =   0
      Top             =   1680
      Width           =   1815
   End
   Begin TextBox txtFirstName 
      DataField       =   "First Name"
      DataSource      =   "Data1"
      Height          =   375
      Left            =   600
      TabIndex        =   2
      Top             =   960
      Width           =   3135
   End
   Begin TextBox txtLastName 
      DataField       =   "Last Name"
      DataSource      =   "Data1"
      Height          =   375
      Left            =   600
      TabIndex        =   1
      Top             =   240
      Width           =   3135
   End
   Begin Label lblRecCount 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Records:0"
      Height          =   255
      Left            =   2640
      TabIndex        =   13
      Top             =   2520
      Width           =   1815
   End
End
Option Explicit

Dim db As database
Dim ds As dynaset
Dim dsfilter As dynaset

Sub cmdEnd_Click ()
    Unload frmFilter
End Sub

Sub cmdFirst_click ()
    dsfilter.MoveFirst
    PlaceDataInControls
End Sub

Sub cmdLast_Click ()
    dsfilter.MoveLast
    PlaceDataInControls
End Sub

Sub cmdLoad_Click ()
    'Open the database, create a table, and show the first record.
    screen.MousePointer = 11
        Set db = OpenDatabase("c:\vbdemos\nwind.mdb")
        Set ds = db.CreateDynaset("Employees")
        Set dsfilter = ds
        GetCount
        PlaceDataInControls

        'Enable and disable the buttons.
        cmdLoad.Enabled = False
        cmdNext.Enabled = True
        cmdPrevious.Enabled = True
        cmdFirst.Enabled = True
        cmdLast.Enabled = True
        frmFiltering.Enabled = True
    screen.MousePointer = 0
End Sub

Sub cmdNext_Click ()
    On Error Resume Next
    
    dsfilter.MoveNext
    If dsfilter.EOF Then
        Beep
        dsfilter.MoveLast
    End If
    PlaceDataInControls
End Sub

Sub cmdPrevious_Click ()
    On Error Resume Next
    
    dsfilter.MovePrevious
    If dsfilter.BOF Then
        Beep
        dsfilter.MoveFirst
    End If
    PlaceDataInControls
End Sub

Sub GetCount ()
    dsfilter.MoveLast
    lblRecCount.Caption = "Records: " & dsfilter.RecordCount
End Sub

Sub optFilterFirst1_Click ()
    ds.Filter = "[First Name] <= 'M'"
    Set dsfilter = ds.CreateDynaset()
    GetCount
    cmdFirst_click
End Sub

Sub optFilterFirst2_Click ()
    ds.Filter = "[First Name] > 'M'"
    Set dsfilter = ds.CreateDynaset()
    GetCount
    cmdFirst_click
End Sub

Sub optFilterLast1_Click ()
    ds.Filter = "[Last Name] <= 'M'"
    Set dsfilter = ds.CreateDynaset()
    GetCount
    cmdFirst_click
End Sub

Sub optFilterLast2_Click ()
    ds.Filter = "[Last Name] > 'M'"
    Set dsfilter = ds.CreateDynaset()
    GetCount
    cmdFirst_click
End Sub

Sub PlaceDataInControls ()
    txtLastName.Text = dsfilter![Last Name]
    txtFirstName.Text = dsfilter![First Name]
End Sub

