VERSION 2.00
Begin Form frmManyView 
   Caption         =   "Manyview: 3 Different RecordSets"
   ClientHeight    =   6120
   ClientLeft      =   105
   ClientTop       =   390
   ClientWidth     =   4755
   Height          =   6525
   Left            =   45
   LinkTopic       =   "Form1"
   ScaleHeight     =   6120
   ScaleWidth      =   4755
   Top             =   45
   Width           =   4875
   Begin CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   375
      Left            =   3360
      TabIndex        =   20
      Top             =   5520
      Width           =   1095
   End
   Begin Frame frmOptions 
      Enabled         =   0   'False
      Height          =   1695
      Left            =   360
      TabIndex        =   16
      Top             =   3240
      Width           =   2175
      Begin OptionButton optSnapshot 
         Caption         =   "Open Snapshot"
         Height          =   255
         Left            =   240
         TabIndex        =   19
         Top             =   1200
         Width           =   1695
      End
      Begin OptionButton optDynaset 
         Caption         =   "Open Dynaset"
         Height          =   375
         Left            =   240
         TabIndex        =   18
         Top             =   720
         Width           =   1695
      End
      Begin OptionButton optTable 
         Caption         =   "Open Table"
         Height          =   375
         Left            =   240
         TabIndex        =   17
         Top             =   240
         Width           =   1695
      End
   End
   Begin TextBox txtID 
      BackColor       =   &H00FFFFFF&
      Enabled         =   0   'False
      ForeColor       =   &H00000000&
      Height          =   285
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   1335
   End
   Begin CommandButton cmdDelete 
      Caption         =   "Delete"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3360
      TabIndex        =   12
      Top             =   2520
      Width           =   1095
   End
   Begin CommandButton cmdCancel 
      Caption         =   "Cancel"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3360
      TabIndex        =   11
      Top             =   4920
      Width           =   1095
   End
   Begin CommandButton cmdSave 
      Caption         =   "Save"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3360
      TabIndex        =   4
      Top             =   4320
      Width           =   1095
   End
   Begin CommandButton cmdAdd 
      Caption         =   "Add"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3360
      TabIndex        =   10
      Top             =   3720
      Width           =   1095
   End
   Begin CommandButton cmdUpdate 
      Caption         =   "Update"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3360
      TabIndex        =   9
      Top             =   3120
      Width           =   1100
   End
   Begin CommandButton cmdLast 
      Caption         =   "Last"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3360
      TabIndex        =   8
      Top             =   1920
      Width           =   1100
   End
   Begin CommandButton cmdFirst 
      Caption         =   "First"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3360
      TabIndex        =   7
      Top             =   1320
      Width           =   1100
   End
   Begin CommandButton cmdPrevious 
      Caption         =   "Previous"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3360
      TabIndex        =   6
      Top             =   720
      Width           =   1100
   End
   Begin CommandButton cmdNext 
      Caption         =   "Next"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3360
      TabIndex        =   5
      Top             =   120
      Width           =   1100
   End
   Begin CommandButton cmdLoad 
      Caption         =   "Load Database"
      Height          =   375
      Left            =   360
      TabIndex        =   2
      Top             =   2640
      Width           =   1815
   End
   Begin TextBox txtFirstName 
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   1920
      Width           =   2655
   End
   Begin TextBox txtLastName 
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   1080
      Width           =   2655
   End
   Begin Label lblID 
      Caption         =   "ID Number"
      Height          =   255
      Left            =   240
      TabIndex        =   15
      Top             =   120
      Width           =   1095
   End
   Begin Label lblFirstName 
      Caption         =   "First Name"
      Height          =   255
      Left            =   240
      TabIndex        =   14
      Top             =   1680
      Width           =   1335
   End
   Begin Label lblLastName 
      Caption         =   "Last Name"
      Height          =   255
      Left            =   240
      TabIndex        =   13
      Top             =   840
      Width           =   975
   End
End
Option Explicit

Const SIZE = 11

Dim RSetType As Integer

Dim MyCommands(SIZE) As commandbutton

Const ERROR_MSG = "You have entered an Employee ID that already exists. Modify Employee ID before proceeding."

Dim db As database
Dim tb As table
Dim ds As dynaset
Dim snp As snapshot

Sub cmdAdd_Click ()
    Dim i As Integer
    
    Select Case RSetType
        Case 1
            tb.AddNew
        Case 2
            ds.AddNew
        Case 3
            Beep
            Exit Sub
    End Select
    
    DisableAllButtons
    
    cmdSave.Enabled = True
    cmdCancel.Enabled = True
    cmdAdd.Enabled = True
    
    'Clear out all 3 text controls
    txtID.Text = ""
    txtLastName = ""
    txtFirstName = ""
    'Enable the KEY field and set the focus to it.
    txtID.Enabled = True
    txtID.SetFocus
End Sub

Sub cmdCancel_Click ()
    Dim i As Integer
    
    Select Case RSetType
        Case 1
            tb.MoveLast
        Case 2
            ds.MoveLast
        Case 3
            snp.MoveLast
    End Select
    PlaceDataInControls
    
    EnableAllButtons
    
    cmdCancel.Enabled = False
    cmdSave.Enabled = False
    txtID.Enabled = False

End Sub

Sub cmdDelete_Click ()
    On Error Resume Next

    Select Case RSetType
        Case 1
            tb.Delete
            tb.MoveNext
            If tb.EOF Then
                tb.MoveLast
            End If
        Case 2
            ds.Delete
            ds.MoveNext
            If ds.EOF Then
                ds.MoveLast
            End If
        Case 3
            snp.Delete
            snp.MoveNext
            If snp.EOF Then
                snp.MoveLast
            End If
    End Select
    PlaceDataInControls
    
End Sub

Sub cmdEnd_Click ()
   Unload frmManyView
End Sub

Sub cmdFirst_Click ()
    Select Case RSetType
        Case 1
            tb.MoveFirst
        Case 2
            ds.MoveFirst
        Case 3
            snp.MoveFirst
    End Select
    PlaceDataInControls
End Sub

Sub cmdLast_Click ()
    Select Case RSetType
        Case 1
            tb.MoveLast
        Case 2
            ds.MoveLast
        Case 3
            snp.MoveLast
    End Select
    PlaceDataInControls
End Sub

Sub cmdLoad_Click ()
    Const HOURGLASS = 11
    Const DEFAULT = 0
    Dim i As Integer
    
    'Load the database, and then disable button #1
    screen.MousePointer = HOURGLASS
    
    Set db = OpenDatabase("c:\vbdemos\nwind.mdb")
    frmOptions.Enabled = True
    optTable_click
    optTable.Value = True
    screen.MousePointer = DEFAULT
    cmdLoad.Enabled = False

End Sub

Sub cmdNext_Click ()
    On Error Resume Next
    
    Select Case RSetType
        Case 1
            tb.MoveNext
            If tb.EOF Then
                tb.MoveLast
            End If
        Case 2
            ds.MoveNext
            If ds.EOF Then
                ds.MoveLast
            End If
        Case 3
            snp.MoveNext
            If snp.EOF Then
                snp.MoveLast
            End If
    End Select
    PlaceDataInControls
End Sub

Sub cmdPrevious_Click ()
    On Error Resume Next
    
    Select Case RSetType
        Case 1
            tb.MovePrevious
            If tb.BOF Then
                tb.MoveFirst
            End If
        Case 2
            ds.MovePrevious
            If ds.BOF Then
                ds.MoveFirst
            End If
        Case 3
            snp.MovePrevious
            If snp.BOF Then
                snp.MoveFirst
            End If
    End Select
    PlaceDataInControls

End Sub

Sub cmdSave_Click ()
    Dim i As Integer

    On Error GoTo SaveError

    Select Case RSetType
        Case 1
            PlaceControlsInDatabase
            tb.Update
        Case 2
            PlaceControlsInDatabase
            ds.Update
        Case 3
            PlaceControlsInDatabase
            snp.Update
    End Select
    
    cmdSave.Enabled = False
    cmdCancel.Enabled = False
    
    'Re-enable all the buttons.
    For i = 2 To 8
        MyCommands(i).Enabled = True
    Next i
    
    'Disable the key field
    txtID.Enabled = False

TerminateSave:
    Exit Sub

SaveError:
    If Err = 3022 Then
        MsgBox ERROR_MSG
        txtID.SelStart = 0
        txtID.SelLength = Len(txtID.Text)
        txtID.SetFocus
    Else
        MsgBox Error$
    End If

    Resume TerminateSave

End Sub

Sub cmdUpdate_Click ()
    On Error GoTo UpdateError

    Select Case RSetType
        Case 1
            tb.Edit
            PlaceControlsInDatabase
            tb.Update
        Case 2
            ds.Edit
            PlaceControlsInDatabase
            ds.Update
        Case 3
            snp.Edit
            PlaceControlsInDatabase
            snp.Update
    End Select
    
    'Re-enable myself and set focus to the Last Name
    cmdUpdate.Enabled = False
    txtLastName.SetFocus

TerminateUpdate:
    Exit Sub

UpdateError:
    If Err = 3022 Then
        MsgBox ERROR_MSG
        txtID.SelStart = 0
        txtID.SelLength = Len(txtID.Text)
        txtID.SetFocus
    Else
        MsgBox Err & Error$
    End If

    Resume TerminateUpdate

End Sub

Sub DisableAllButtons ()
    Dim i As Integer
    
    For i = 2 To SIZE
        MyCommands(i).Enabled = False
    Next i
End Sub

Sub EnableAllButtons ()
    Dim i As Integer
    
    For i = 2 To SIZE
        MyCommands(i).Enabled = True
    Next i
    cmdUpdate.Enabled = False
End Sub

Sub Form_Load ()
    'Stuff the command buttons into an array for easier processing.
    'NOTE: the order here is to facilitate processing the
    'buttons with a for loop, and is not exactly the order
    'the buttons appear on the screen.
    Set MyCommands(1) = cmdLoad
    
    Set MyCommands(2) = cmdNext
    Set MyCommands(3) = cmdPrevious
    Set MyCommands(4) = cmdFirst
    Set MyCommands(5) = cmdLast
    Set MyCommands(6) = cmdLast
    Set MyCommands(7) = cmdDelete
    Set MyCommands(8) = cmdAdd
    
    Set MyCommands(9) = cmdUpdate
    
    Set MyCommands(10) = cmdSave
    Set MyCommands(11) = cmdCancel
    
    Width = screen.Width / 2
    If app.PrevInstance Then
        Left = screen.Width / 2
    Else
        Left = 0
    End If

End Sub

Sub Form_Unload (Cancel As Integer)
    On Error Resume Next
    
    Close tb
    Set tb = Nothing
    Close ds
    Set ds = Nothing
    Close snp
    Set snp = Nothing
    Close db
    Set db = Nothing
End Sub

Sub optDynaset_Click ()
    Select Case RSetType
        Case 1
            tb.Close
        Case 2
            ds.Close
        Case 3
            snp.Close
    End Select
    Set ds = db.CreateDynaset("Employees")
    
    'In order to create the entire dynaset at this instant,
    'it's necessary to move to the last record. If this step
    'is not performed, only a portion of the dynaset is actually
    'buffered at this time.
    'ds.MoveLast
    'ds.MoveFirst
    
    RSetType = 2
    If ds.EOF And ds.BOF Then
        DisableAllButtons
        cmdAdd.Enabled = True
        cmdAdd.SetFocus
    Else
        EnableAllButtons
        cmdCancel.Enabled = False
        cmdSave.Enabled = False
        PlaceDataInControls
        cmdNext.SetFocus
    End If
End Sub

Sub optSnapshot_Click ()
    Select Case RSetType
        Case 1
            tb.Close
        Case 2
            ds.Close
        Case 3
            snp.Close
    End Select
    Set snp = db.CreateSnapshot("Employees")
    
    'In order to create the entire snapshot at this instant,
    'it's necessary to move to the last record. If this step
    'is not performed, only a portion of the snapshot is actually
    'buffered at this time.
    'snp.MoveLast
    'snp.MoveFirst

    RSetType = 3
    If snp.EOF And snp.BOF Then
        DisableAllButtons
        cmdAdd.Enabled = True
        cmdAdd.SetFocus
    Else
        EnableAllButtons
        cmdCancel.Enabled = False
        cmdSave.Enabled = False
        PlaceDataInControls
        cmdNext.SetFocus
    End If
End Sub

Sub optTable_click ()
    Select Case RSetType
        Case 1
            tb.Close
        Case 2
            ds.Close
        Case 3
            snp.Close
    End Select
    
    Set tb = db.OpenTable("employees")
    RSetType = 1
    
    'In order to prevent errors, it's necessary to deal with an
    'empty table. For an empty table, the ONLY button that can
    'be enabled is the ADD button.
    If tb.EOF And tb.BOF Then
        DisableAllButtons
        cmdAdd.Enabled = True
        cmdAdd.SetFocus
    Else
        EnableAllButtons
        cmdCancel.Enabled = False
        cmdSave.Enabled = False
        PlaceDataInControls
        cmdNext.SetFocus
    End If
End Sub

Sub PlaceControlsInDatabase ()
    Select Case RSetType
        Case 1
            tb![Last Name] = txtLastName.Text
            tb![First Name] = txtFirstName.Text
        Case 2
            ds![Last Name] = txtLastName.Text
            ds![First Name] = txtFirstName.Text
        Case 3
            snp![Last Name] = txtLastName.Text
            snp![First Name] = txtFirstName.Text
    End Select
End Sub

Sub PlaceDataInControls ()
    Select Case RSetType
        Case 1
            txtID.Text = tb![employee id]
            txtLastName.Text = tb![Last Name]
            txtFirstName.Text = tb![First Name]
        Case 2
            txtID.Text = ds![employee id]
            txtLastName.Text = ds![Last Name]
            txtFirstName.Text = ds![First Name]
        Case 3
            txtID.Text = snp![employee id]
            txtLastName.Text = snp![Last Name]
            txtFirstName.Text = snp![First Name]
    End Select
End Sub

Sub txtFirstName_Change ()
    If cmdSave.Enabled = False Then
        cmdUpdate.Enabled = True
    End If
End Sub

Sub txtID_Change ()
    If cmdSave.Enabled = False Then
        cmdUpdate.Enabled = True
    End If
End Sub

Sub txtLastName_Change ()
    If cmdSave.Enabled = False Then
        cmdUpdate.Enabled = True
    End If
End Sub

