VERSION 2.00
Begin Form Form1 
   Caption         =   ".INI Sample"
   ClientHeight    =   2805
   ClientLeft      =   1710
   ClientTop       =   1830
   ClientWidth     =   3945
   Height          =   3495
   Left            =   1650
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   2805
   ScaleWidth      =   3945
   Top             =   1200
   Width           =   4065
   Begin PictureBox Picture1 
      BackColor       =   &H00000080&
      Height          =   2055
      Left            =   360
      ScaleHeight     =   2025
      ScaleWidth      =   3225
      TabIndex        =   0
      Top             =   240
      Width           =   3255
   End
   Begin Menu FileMenu 
      Caption         =   "&File"
      Begin Menu QuitItem 
         Caption         =   "&Quit"
      End
   End
   Begin Menu ColorMenu 
      Caption         =   "&Colors"
      Begin Menu RedItem 
         Caption         =   "&Red"
      End
      Begin Menu YellowItem 
         Caption         =   "&Yellow"
      End
      Begin Menu BlueItem 
         Caption         =   "&Blue"
      End
      Begin Menu GreenItem 
         Caption         =   "&Green"
      End
      Begin Menu BlackItem 
         Caption         =   "Blac&k"
      End
      Begin Menu WhiteItem 
         Caption         =   "&White"
      End
   End
   Begin Menu MenuMenu 
      Caption         =   "&Menu"
      Begin Menu ChangeItem 
         Caption         =   "&Change title..."
      End
   End
End
Option Explicit

Dim squarecolor As Integer

Declare Function GetPrivateProfileInt Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Integer, ByVal lpFileName As String) As Integer
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lplFileName As String) As Integer

Sub BlackItem_Click ()
    picture1.BackColor = QBColor(0)
    squarecolor = 0
End Sub

Sub BlueItem_Click ()
    picture1.BackColor = QBColor(1)
    squarecolor = 1
End Sub

Sub ChangeItem_Click ()
    Dim newTitle As String
    newTitle = InputBox$("Enter a new form title. (Only the first 15 characters will be saved.)", "Change Title", form1.Caption)
    form1.Caption = newTitle
End Sub

Sub Form_Load ()
    Dim rc As Integer
    Dim keyvalue As String, keydefault As String, keyname As String
    Dim sectionname As String, filename As String

    filename = "SAMPLE.INI"
    sectionname = "INI Sample"
    keyname = "title"
    keydefault = "INI Sample"
    keyvalue = String$(16, 0)

    rc = GetPrivateProfileString(sectionname, keyname, keydefault, keyvalue, Len(keyvalue), filename)
    form1.Caption = keyvalue
    form1.Top = GetPrivateProfileInt(sectionname, "top", 1200, filename)
    form1.Left = GetPrivateProfileInt(sectionname, "left", 1650, filename)
    form1.Height = GetPrivateProfileInt(sectionname, "height", 3495, filename)
    form1.Width = GetPrivateProfileInt(sectionname, "width", 4065, filename)
    squarecolor = GetPrivateProfileInt(sectionname, "color", 6, filename)
    picture1.BackColor = QBColor(squarecolor)
End Sub

Sub Form_Unload (Cancel As Integer)
    WriteMyIni
    End
End Sub

Sub GreenItem_Click ()
    picture1.BackColor = QBColor(2)
    squarecolor = 2
End Sub

Sub QuitItem_Click ()
    Unload form1
End Sub

Sub RedItem_Click ()
    picture1.BackColor = QBColor(4)
    squarecolor = 4
End Sub

Sub WhiteItem_Click ()
    picture1.BackColor = QBColor(15)
    squarecolor = 15
End Sub

Sub WriteMyIni ()
    Dim rc As Integer
    Dim keyname As String
    Dim keyvalue As String
    Dim sectionname As String, filename As String

    sectionname = "INI Sample"
    filename = "sample.ini"

    keyname = "Top"
    keyvalue = Str$(form1.Top)
    rc = WritePrivateProfileString(sectionname, keyname, keyvalue, filename)
    
    keyname = "Left"
    keyvalue = Str$(form1.Left)
    rc = WritePrivateProfileString(sectionname, keyname, keyvalue, filename)
    
    keyname = "Width"
    keyvalue = Str$(form1.Width)
    rc = WritePrivateProfileString(sectionname, keyname, keyvalue, filename)

    keyname = "height"
    keyvalue = Str$(form1.Height)
    rc = WritePrivateProfileString(sectionname, keyname, keyvalue, filename)

    keyname = "Color"
    keyvalue = Str$(squarecolor)
    rc = WritePrivateProfileString(sectionname, keyname, keyvalue, filename)

    keyname = "Title"
    keyvalue = Left$(form1.Caption, 15)
    rc = WritePrivateProfileString(sectionname, keyname, keyvalue, filename)
End Sub

Sub YellowItem_Click ()
    picture1.BackColor = QBColor(14)
    squarecolor = 14
End Sub

