VERSION 2.00
Begin Form Form1 
   Caption         =   "Text Viewer"
   ClientHeight    =   5250
   ClientLeft      =   270
   ClientTop       =   1725
   ClientWidth     =   9120
   Height          =   5940
   Icon            =   ERRORH.FRX:0000
   Left            =   210
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   5250
   ScaleWidth      =   9120
   Top             =   1095
   Width           =   9240
   Begin DriveListBox Drive1 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1455
   End
   Begin TextBox Text1 
      Height          =   5060
      Left            =   1680
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      Top             =   120
      Width           =   7335
   End
   Begin DirListBox Dir1 
      Height          =   1580
      Left            =   120
      TabIndex        =   1
      Top             =   600
      Width           =   1455
   End
   Begin FileListBox File1 
      Height          =   2565
      Left            =   120
      Pattern         =   "*.txt"
      TabIndex        =   2
      Top             =   2280
      Width           =   1455
   End
   Begin Menu FileMenu 
      Caption         =   "&File"
      Begin Menu FileOpen 
         Caption         =   "&Open"
         Enabled         =   0   'False
      End
      Begin Menu FileExit 
         Caption         =   "E&xit"
      End
   End
   Begin Menu EditMenu 
      Caption         =   "&Edit"
      Begin Menu EditCopy 
         Caption         =   "&Copy"
      End
   End
   Begin Menu HelpMenu 
      Caption         =   "&Help"
      Begin Menu HelpAbout 
         Caption         =   "&About"
      End
   End
End
Option Explicit

Const DEFAULT = 0        ' 0 - Default
Const HOURGLASS = 11     ' 11 - Hourglass

Dim crlf As String

Sub Dir1_Change ()
    File1.Path = dir1.Path
End Sub

Sub DisplayFile ()
    Dim Rc As Integer
    Dim fname As String
    Dim fhandle As Integer
    Dim ThisLine As String, FileContents As String

    On Error GoTo ErrorTrap
    
    If Right$(dir1.Path, 1) = "\" Then
	fname = dir1.Path + File1.FileName
    Else
	fname = dir1.Path + "\" + File1.FileName
    End If
    fhandle = FreeFile
	
    Open fname For Input As fhandle

    MousePointer = HOURGLASS
    While Not EOF(fhandle)
	Line Input #fhandle, ThisLine
	FileContents = FileContents + crlf + ThisLine
    Wend
    Close fhandle
    Text1.Text = FileContents
ErrorReturn:
    MousePointer = DEFAULT
    Exit Sub

ErrorTrap:
    Select Case Err
	Case 68 'Drive Not Ready
	    Rc = DriveError(Err)
	Case 14 'File Too Large
	    MsgBox "This file is too large to view", 48, "FileView"
	    Close fhandle
	    Text1.Text = ""
	    Resume ErrorReturn
	Case Else
	    MsgBox "Unexpected Error # " + Str$(Err) + crlf + Error$, 16, "FileView Error"
	    Close fhandle
	    End
    End Select
    
    Select Case Rc
	Case 4 'Retry
	    Resume
	Case 5 'Ignore
	    Resume Next
	Case 3 'Abort
	    Drive1.Drive = Left$(dir1.Path, 2)
	    Resume
	Case Else
	    MsgBox "Unexpected Result in Error Routine:" + Str$(Rc), 16, "FileView Error"
	    Close fhandle
	    End
	End Select

End Sub

Sub Drive1_Change ()
    Dim Rc As Integer

    On Error GoTo DriveError
    
    dir1.Path = Drive1.Drive
    Exit Sub

DriveError:
    Select Case Err
	Case 68
	    Rc = DriveError(Err)
	Case Else
	    MsgBox "Unexpected Error # " + Str$(Err) + crlf + Error$, 16, "FileView Error"
	    Close
	    End
    End Select
    
    Select Case Rc
	Case 4 'Retry
	    Resume
	Case 5 'Ignore
	    Resume Next
	Case 3 'Abort
	    Drive1.Drive = Left$(dir1.Path, 2)
	    Resume
	Case Else
	    MsgBox "Unexpected Result in Error Routine:" + Str$(Rc), 16, "FileView Error"
	    Close
	    End
    End Select

End Sub

Function DriveError (ErrorCode As Integer)
    Select Case ErrorCode
	Case 68
	    DriveError = MsgBox("Drive not ready", 50, "FileView")
	Case Else
	    DriveError = 0
    End Select
End Function

Sub EditCopy_Click ()
    If Text1.SelLength = 0 Then
	ClipBoard.SetText Text1.Text
    Else
	ClipBoard.SetText Text1.SelText
    End If
End Sub

Sub EditMenu_Click ()
    If Len(Text1.Text) = 0 Then
	EditCopy.Enabled = False
    Else
	EditCopy.Enabled = True
    End If
End Sub

Sub File1_DblClick ()
    DisplayFile
End Sub

Sub FileExit_Click ()
    End
End Sub

Sub FileMenu_Click ()
    If File1.FileName <> "" Then
	FileOpen.Enabled = True
    Else
	FileOpen.Enabled = False
    End If

End Sub

Sub FileOpen_Click ()
    DisplayFile
End Sub

Sub Form_Load ()
    'This string is need many places in the program.
    crlf = Chr$(13) + Chr$(10)

    'Establish the initial subdirectory
    dir1.Path = "c:\vbdemos\errors"
End Sub

Sub HelpAbout_Click ()
    MsgBox "A Simple Text File Viewer", 64, "File Viewer"
End Sub

