VERSION 2.00
Begin Form Form1 
   Caption         =   "KeyDown Demonstration"
   ClientHeight    =   5010
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   7365
   Height          =   5415
   Left            =   1035
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   5010
   ScaleWidth      =   7365
   Top             =   1140
   Width           =   7485
   Begin TextBox Text2 
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   18
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   1095
      Left            =   1920
      TabIndex        =   2
      Top             =   3720
      Width           =   3255
   End
   Begin TextBox Text1 
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   18
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   1095
      Left            =   1920
      TabIndex        =   0
      Top             =   1320
      Width           =   3255
   End
   Begin Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Keyboard State"
      Height          =   255
      Left            =   2760
      TabIndex        =   3
      Top             =   3360
      Width           =   1815
   End
   Begin Label Label1 
      Alignment       =   2  'Center
      Caption         =   "As you press keystrokes, this program will tell you what they are."
      Height          =   495
      Left            =   2040
      TabIndex        =   1
      Top             =   360
      Width           =   3135
   End
End
Option Explicit

Dim keystrings(256) As String
Dim AscStrings(128) As String

Const SHIFT_MASK = 1
Const CTRL_MASK = 2
Const ALT_MASK = 4

Sub Form_Load ()
    Dim i As Integer

    keystrings(&H1) = "KEY_LBUTTON"
    keystrings(&H2) = "KEY_RBUTTON"
    keystrings(&H3) = "KEY_CANCEL"
    keystrings(&H4) = "KEY_MBUTTON"
    keystrings(&H8) = "KEY_BACK"
    keystrings(&H9) = "KEY_TAB"
    keystrings(&HC) = "KEY_CLEAR"
    keystrings(&HD) = "KEY_RETURN"
    keystrings(&H10) = "KEY_SHIFT"
    keystrings(&H11) = "KEY_CONTROL"
    keystrings(&H12) = "KEY_MENU"
    keystrings(&H13) = "KEY_PAUSE"
    keystrings(&H14) = "KEY_CAPITAL"
    keystrings(&H1B) = "KEY_ESCAPE"
    keystrings(&H20) = "KEY_SPACE"
    keystrings(&H21) = "KEY_PRIOR"
    keystrings(&H22) = "KEY_NEXT"
    keystrings(&H23) = "KEY_END"
    keystrings(&H24) = "KEY_HOME"
    keystrings(&H25) = "KEY_LEFT"
    keystrings(&H26) = "KEY_UP"
    keystrings(&H27) = "KEY_RIGHT"
    keystrings(&H28) = "KEY_DOWN"
    keystrings(&H29) = "KEY_SELECT"
    keystrings(&H2A) = "KEY_PRINT"
    keystrings(&H2B) = "KEY_EXECUTE"
    keystrings(&H2C) = "KEY_SNAPSHOT"
    keystrings(&H2D) = "KEY_INSERT"
    keystrings(&H2E) = "KEY_DELETE"
    keystrings(&H2F) = "KEY_HELP"
    
    For i = &H30 To &H39
	keystrings(i) = "KEY_"
    Next i

    For i = &H41 To &H5A
	keystrings(i) = "KEY_"
    Next i

    For i = 0 To 127
	AscStrings(i) = Chr$(i)
    Next i

    keystrings(&H60) = "KEY_NUMPAD0"
    keystrings(&H61) = "KEY_NUMPAD1"
    keystrings(&H62) = "KEY_NUMPAD2"
    keystrings(&H63) = "KEY_NUMPAD3"
    keystrings(&H64) = "KEY_NUMPAD4"
    keystrings(&H65) = "KEY_NUMPAD5"
    keystrings(&H66) = "KEY_NUMPAD6"
    keystrings(&H67) = "KEY_NUMPAD7"
    keystrings(&H68) = "KEY_NUMPAD8"
    keystrings(&H69) = "KEY_NUMPAD9"
    keystrings(&H6A) = "KEY_MULTIPLY"
    keystrings(&H6B) = "KEY_ADD"
    keystrings(&H6C) = "KEY_SEPARATOR"
    keystrings(&H6D) = "KEY_SUBTRACT"
    keystrings(&H6E) = "KEY_DECIMAL"
    keystrings(&H6F) = "KEY_DIVIDE"
    keystrings(&H70) = "KEY_F1"
    keystrings(&H71) = "KEY_F2"
    keystrings(&H72) = "KEY_F3"
    keystrings(&H73) = "KEY_F4"
    keystrings(&H74) = "KEY_F5"
    keystrings(&H75) = "KEY_F6"
    keystrings(&H76) = "KEY_F7"
    keystrings(&H77) = "KEY_F8"
    keystrings(&H78) = "KEY_F9"
    keystrings(&H79) = "KEY_F10"
    keystrings(&H7A) = "KEY_F11"
    keystrings(&H7B) = "KEY_F12"
    keystrings(&H7C) = "KEY_F13"
    keystrings(&H7D) = "KEY_F14"
    keystrings(&H7E) = "KEY_F15"
    keystrings(&H7F) = "KEY_F16"
    
    For i = &H80 To &HFF
	keystrings(i) = "key_"
    Next i
    
    keystrings(&H90) = "KEY_NUMLOCK"

End Sub

Sub Text1_KeyDown (keycode As Integer, shift As Integer)
    text1.Text = keystrings(keycode)
    
    If shift And SHIFT_MASK Then
	text2.Text = "SHIFT"
    ElseIf shift And CTRL_MASK Then
	    text2.Text = "CONTROL"
	ElseIf shift And ALT_MASK Then
		text2.Text = "ALTERNATE"
	    Else
		text2.Text = ""
    End If

End Sub

Sub Text1_KeyPress (keyascii As Integer)
    text1.Text = text1 + AscStrings(keyascii)
    keyascii = 0
End Sub

