VERSION 2.00
Begin Form frmMale 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FF8080&
   ClientHeight    =   4035
   ClientLeft      =   1095
   ClientTop       =   1770
   ClientWidth     =   7365
   Height          =   4725
   Icon            =   FRMMALE.FRX:0000
   Left            =   1035
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   4035
   ScaleWidth      =   7365
   Top             =   1140
   Width           =   7485
   Begin CommandButton cmdBoyMakeDirty 
      Caption         =   "Set the Dirty Flag"
      Height          =   495
      Left            =   2760
      TabIndex        =   0
      Top             =   1800
      Width           =   2055
   End
   Begin Menu mnuFile 
      Caption         =   "&File"
      Begin Menu mnuFileBoy 
         Caption         =   "Open New &Boy"
      End
      Begin Menu mnuFileGirl 
         Caption         =   "Open New &Girl"
      End
      Begin Menu mnuSep1 
         Caption         =   "-"
      End
      Begin Menu mnuFileSave 
         Caption         =   "&Save This Boy"
      End
      Begin Menu mnuFileClose 
         Caption         =   "&Close This Boy"
      End
      Begin Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin Menu mnuMinmax 
      Caption         =   "&MinMax"
      Begin Menu mnuMinmaxMinimize 
         Caption         =   "&Minimize All Boys"
      End
      Begin Menu mnuMinmaxRestore 
         Caption         =   "&Restore All Boys"
      End
      Begin Menu mnuMinmaxEverybody 
         Caption         =   "Restore All &Children"
      End
   End
   Begin Menu mnuWindow 
      Caption         =   "&Window"
      WindowList      =   -1  'True
      Begin Menu mnuWindowTilevert 
         Caption         =   "Tile &Vertically"
      End
      Begin Menu mnuWindowTilehorz 
         Caption         =   "Tile &Horizontally"
      End
      Begin Menu mnuWindowCascade 
         Caption         =   "&Cascade"
      End
      Begin Menu mnuWindowArrange 
         Caption         =   "&Arrange Icons"
      End
   End
   Begin Menu mnuHelp 
      Caption         =   "&Help"
      Begin Menu mnuHelpAbout 
         Caption         =   "About Me"
      End
   End
End
Option Explicit

Const NO_QUERY = False
Const DO_QUERY = True

Sub cmdBoyMakeDirty_Click ()
    Dim i As Single
    Dim start As Single
    Dim ending As Single
    Dim increment As Single

    'Draw horizontal lines to dirty a male child.
    start = .1 * Me.ScaleHeight
    increment = .1 * Me.ScaleHeight
    ending = .9 * Me.ScaleHeight
    For i = start To ending Step increment
        Line (0, i)-(Me.ScaleWidth, i)
    Next i
    
    'Hide this button
    cmdBoyMakeDirty.Visible = False

    i = Val(Me.Tag)
    boydata(i).dirtyflag = True
End Sub

Sub Form_Activate ()
    MDIParent.lblStatus(1).Caption = "MENU: BOY"
    MDIParent.lblStatus(2).Caption = "Boy Child #" + Me.Tag
    MDIParent.lblStatus(3).Caption = "Windowstate: " + GetWindowState(Me)
End Sub

Sub Form_Resize ()
    CenterControl cmdBoyMakeDirty
    MDIParent.lblStatus(3).Caption = "Windowstate: " + GetWindowState(Me)
End Sub

Sub Form_Unload (Cancel As Integer)
    SaveThisBoy DO_QUERY
    CloseCurrentBoy Val(Me.Tag)
End Sub

Sub mnuFileBoy_Click ()
    CreateNewBoy
End Sub

Sub mnuFileClose_Click ()
    Unload Me
End Sub

Sub mnuFileExit_Click ()
    'Unloading the parent will cause QueryUnload to be
    'invoked for each of the children.
    Unload MDIParent
End Sub

Sub mnuFileGirl_Click ()
    CreateNewGirl
End Sub

Sub mnuFileSave_Click ()
    SaveThisBoy NO_QUERY
End Sub

Sub mnuHelpAbout_Click ()
    frmOrphan.Show
End Sub

Sub mnuMinmaxEverybody_Click ()
    Dim i As Integer

    On Error Resume Next

    For i = 0 To forms.Count - 1
        If (forms(i).MDIChild = True) Then
            forms(i).WindowState = NORMAL
        End If
    Next i

End Sub

Sub mnuMinmaxMinimize_Click ()
    Dim i As Integer
    
    For i = 1 To currentboy - 1
        If boys(i) Is Nothing Then
            'nothing to do
        Else
            boys(i).WindowState = MINIMIZED
        End If
    Next i

End Sub

Sub mnuMinmaxRestore_Click ()
    Dim i As Integer
    
    For i = 1 To currentboy - 1
        If boys(i) Is Nothing Then
            'nothing to do
        Else
            boys(i).WindowState = NORMAL
        End If
    Next i

End Sub

Sub mnuWindowArrange_Click ()
    MDIParent.Arrange ARRANGE_ICONS
End Sub

Sub mnuWindowCascade_Click ()
    MDIParent.Arrange CASCADE
End Sub

Sub mnuWindowTilehorz_Click ()
    MDIParent.Arrange TILE_HORIZONTAL
End Sub

Sub mnuWindowTilevert_Click ()
    MDIParent.Arrange TILE_VERTICAL
End Sub

Sub SaveThisBoy (QueryFirst As Integer)
    Dim i As Integer, rc As Integer
    Dim msgtype As Integer
    
    i = Val(Me.Tag)
    If (boydata(i).dirtyflag = False) Then
        Exit Sub
    End If

    msgtype = MB_YESNO + MB_ICONQUESTION

    If (QueryFirst = True) Then
        rc = MsgBox(boys(i).Caption + " has changed. Save?", msgtype)
    Else
        rc = IDYES
    End If

    If (rc = IDYES) Then
        Cls
        boydata(i).dirtyflag = False
        cmdBoyMakeDirty.Visible = True
    End If
End Sub

