VERSION 2.00
Begin Form sss 
   Caption         =   "Dynamic Menu Demonstration"
   ClientHeight    =   4020
   ClientLeft      =   1185
   ClientTop       =   1800
   ClientWidth     =   6645
   Height          =   4710
   Left            =   1125
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   4020
   ScaleWidth      =   6645
   Top             =   1170
   Width           =   6765
   Begin TextBox Text1 
      Height          =   1335
      Left            =   600
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   2040
      Width           =   1815
   End
   Begin TextBox Text2 
      Height          =   1335
      Left            =   3600
      TabIndex        =   1
      Text            =   "Text2"
      Top             =   2040
      Width           =   2055
   End
   Begin Label Label1 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Notice the CUT/COPY menu items are only enabled if some text has been selected.  "
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   480
      Left            =   1080
      TabIndex        =   2
      Top             =   240
      Width           =   4875
   End
   Begin Label Label2 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Screen.ActiveControl is used to determine active control."
      Height          =   495
      Left            =   1560
      TabIndex        =   3
      Top             =   1200
      Width           =   3375
   End
   Begin Menu mnuFile 
      Caption         =   "&File"
      Begin Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin Menu mnuEdit 
      Caption         =   "&Edit"
      Begin Menu mnuEditCut 
         Caption         =   "Cu&t"
         Shortcut        =   ^X
      End
      Begin Menu mnuEditCopy 
         Caption         =   "&Copy"
         Shortcut        =   ^C
      End
      Begin Menu mnuEditPaste 
         Caption         =   "&Paste"
         Shortcut        =   ^V
      End
   End
End
Option Explicit

Sub Form_Load ()
    clipboard.Clear
End Sub

Sub mnuEdit_Click ()
    Const CF_TEXT = 1

    'Enable Cut and Copy only if some text is selected
    'Screen.ActiveControl refers to control which currently
    'has focus

    If Screen.ActiveControl.SelLength > 0 Then
        mnuEditCopy.Enabled = True
        mnuEditCut.Enabled = True
    Else
        mnuEditCopy.Enabled = False
        mnuEditCut.Enabled = False
    End If

    mnuEditPaste.Enabled = clipboard.GetFormat(CF_TEXT)

End Sub

Sub mnuEditCopy_Click ()
    clipboard.SetText Screen.ActiveControl.SelText
End Sub

Sub mnuEditCut_Click ()
    clipboard.SetText Screen.ActiveControl.SelText
    Screen.ActiveControl.SelText = ""
End Sub

Sub mnuEditPaste_Click ()
    Screen.ActiveControl.SelText = clipboard.GetText()
End Sub

Sub mnuFileExit_Click ()
    End
End Sub

