VERSION 2.00
Begin Form Form1 
   Caption         =   "Demonstration of Dragging a Control"
   ClientHeight    =   4020
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   7365
   Height          =   4425
   Left            =   1035
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   4020
   ScaleWidth      =   7365
   Top             =   1140
   Width           =   7485
   Begin FileListBox File1 
      Height          =   1200
      Left            =   240
      TabIndex        =   1
      Top             =   1440
      Width           =   2175
   End
   Begin ListBox List2 
      Height          =   1200
      Left            =   4320
      TabIndex        =   0
      Top             =   1440
      Width           =   2055
   End
   Begin Image Image2 
      Height          =   840
      Left            =   2280
      Picture         =   DRAG.FRX:0000
      Stretch         =   -1  'True
      Top             =   2880
      Width           =   975
   End
   Begin Image Image1 
      Height          =   960
      Left            =   960
      Picture         =   DRAG.FRX:0302
      Stretch         =   -1  'True
      Top             =   2880
      Width           =   855
   End
   Begin Label Label1 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Drag a file name from the file list box to the ordinary list box.  Notice that the drag icon changes."
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   615
      Left            =   960
      TabIndex        =   2
      Top             =   240
      Width           =   5415
   End
End
Option Explicit

' DragOver
Const ENTER = 0
Const LEAVE = 1
Const OVER = 2

' Drag (controls)
Const CANCEL = 0
Const BEGIN_DRAG = 1
Const END_DRAG = 2

Sub File1_DragOver (Source As Control, x As Single, y As Single, state As Integer)
    If state = ENTER Then File1.DragIcon = image1.Picture
    If state = LEAVE Then File1.DragIcon = image2.Picture
End Sub

Sub File1_MouseDown (Button As Integer, Shift As Integer, x As Single, y As Single)
    File1.Drag BEGIN_DRAG
End Sub

Sub Form_Load ()
    'Comment out this next line and note how the
    'program runs differently. A drag icon MUST
    'be established before the first dragging action.
    File1.DragIcon = image1.Picture
End Sub

Sub List2_DragDrop (Source As Control, x As Single, y As Single)
    If TypeOf Source Is FileListBox Then
	list2.AddItem File1.FileName
    End If
End Sub

Sub List2_DragOver (Source As Control, x As Single, y As Single, state As Integer)
    If state = ENTER Then File1.DragIcon = image1.Picture
    If state = LEAVE Then File1.DragIcon = image2.Picture
End Sub

