VERSION 2.00
Begin Form frmOutline 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Form1"
   ClientHeight    =   5025
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   6570
   Height          =   5430
   Left            =   1035
   LinkTopic       =   "Form1"
   ScaleHeight     =   5025
   ScaleWidth      =   6570
   Top             =   1140
   Width           =   6690
   Begin Outline Outline1 
      Height          =   3255
      Left            =   720
      PictureClosed   =   OUTLINE.FRX:0000
      PictureLeaf     =   OUTLINE.FRX:00E2
      PictureMinus    =   OUTLINE.FRX:01C4
      PictureOpen     =   OUTLINE.FRX:02A6
      PicturePlus     =   OUTLINE.FRX:0388
      TabIndex        =   0
      Top             =   240
      Width           =   5295
   End
   Begin CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   495
      Left            =   2640
      TabIndex        =   2
      Top             =   3840
      Width           =   1575
   End
   Begin CommandButton cmdLoadDB 
      Caption         =   "Load Database"
      Height          =   495
      Left            =   840
      TabIndex        =   1
      Top             =   3840
      Width           =   1575
   End
End
Option Explicit

Dim db As database
Dim ds As dynaset
Dim dstitles As dynaset

Sub cmdEnd_Click ()
    Unload frmOutline
End Sub

Sub cmdFirst_Click ()
    ds.MoveFirst
    placeDataInControls
End Sub

Sub cmdLoadDB_Click ()
    Set db = OpenDatabase("c:\vb\biblio.mdb")
    Set ds = db.CreateDynaset("select author, au_id from authors")

    cmdFirst_Click
End Sub

Sub Form_Unload (Cancel As Integer)
    On Error Resume Next
    ds.Close
    dstitles.Close
    db.Close
End Sub

Sub gettitles (itemnumber As Integer)
    Dim i As Integer
    Dim auid As String
    Dim sql As String

    'Get author id - The author id was placed in outline control
    'with author name Ex: "Jones, Tom (123)"
    auid = outline1.List(itemnumber)
    i = InStr(auid, "(")
    If i = 0 Then Exit Sub
    
    auid = Right$(auid, Len(auid) - i)
    'drop off ending paren
    auid = Left$(auid, Len(auid) - 1)
                        
    'Build SQL statement
    sql = "Select title from titles where au_id = " & auid
    Set dstitles = db.CreateDynaset(sql)
    
    'Add titles to outline control.
    'Need to add to correct location and set indent appropriately
    Do Until dstitles.EOF
        outline1.AddItem dstitles("title"), (itemnumber + 1)
        outline1.Indent(itemnumber + 1) = 2
        dstitles.MoveNext
    Loop
End Sub

Sub Outline1_DblClick ()

    'Check if currently expanded
    If outline1.Expand(outline1.ListIndex) = True Then
         outline1.Expand(outline1.ListIndex) = False
    Else
       'Check if titles have already been retrieved once
       If outline1.HasSubItems(outline1.ListIndex) = False Then
          gettitles (outline1.ListIndex)
       End If

       'Expand author to show titles.
       outline1.Expand(outline1.ListIndex) = True
    End If

End Sub

Sub placeDataInControls ()
    'This procedure adds author names and ids to outline control
    While Not ds.EOF
        'Include au_id in list box - you will need it for lookup later
        outline1.AddItem ds("author") & "(" & ds("au_id") & ")"
        ds.MoveNext
    Wend
End Sub

