VERSION 2.00
Begin Form Form1 
   Caption         =   "Visual Basic Publications"
   ClientHeight    =   5010
   ClientLeft      =   780
   ClientTop       =   1380
   ClientWidth     =   6825
   Height          =   5415
   Left            =   720
   LinkTopic       =   "Form1"
   ScaleHeight     =   5010
   ScaleWidth      =   6825
   Top             =   1035
   Width           =   6945
   Begin CommandButton cmdFind 
      Caption         =   "Find"
      Height          =   495
      Left            =   5760
      TabIndex        =   10
      Top             =   3120
      Width           =   855
   End
   Begin CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   495
      Left            =   5760
      TabIndex        =   9
      Top             =   3840
      Width           =   855
   End
   Begin CommandButton cmdLast 
      Caption         =   "Last"
      Height          =   495
      Left            =   5760
      TabIndex        =   8
      Top             =   2400
      Width           =   855
   End
   Begin CommandButton cmdFirst 
      Caption         =   "First"
      Height          =   495
      Left            =   5760
      TabIndex        =   7
      Top             =   1680
      Width           =   855
   End
   Begin CommandButton cmdPrev 
      Caption         =   "Previous"
      Height          =   495
      Left            =   5760
      TabIndex        =   6
      Top             =   960
      Width           =   855
   End
   Begin CommandButton cmdNext 
      Caption         =   "Next"
      Height          =   495
      Left            =   5760
      TabIndex        =   5
      Top             =   240
      Width           =   855
   End
   Begin CommandButton cmdLoad 
      Caption         =   "Load Database"
      Height          =   495
      Left            =   2400
      TabIndex        =   4
      Top             =   3240
      Width           =   2055
   End
   Begin TextBox txtTitle 
      DataSource      =   "Data1"
      Height          =   495
      Left            =   1440
      TabIndex        =   1
      Top             =   600
      Width           =   3975
   End
   Begin TextBox txtAuthor 
      DataSource      =   "Data1"
      Height          =   495
      Left            =   1440
      TabIndex        =   0
      Top             =   1560
      Width           =   3975
   End
   Begin Data Data1 
      Caption         =   "Data1"
      Connect         =   ""
      DatabaseName    =   "D:\VB3\BIBLIO.MDB"
      Exclusive       =   0   'False
      Height          =   375
      Left            =   1440
      Options         =   0
      ReadOnly        =   0   'False
      RecordSource    =   "Publisher Comments"
      Top             =   2520
      Width           =   3975
   End
   Begin Label Label2 
      Caption         =   "Title"
      Height          =   255
      Left            =   480
      TabIndex        =   3
      Top             =   720
      Width           =   615
   End
   Begin Label Label1 
      Caption         =   "Author"
      Height          =   255
      Left            =   480
      TabIndex        =   2
      Top             =   1680
      Width           =   615
   End
End
Option Explicit

Sub cmdEnd_Click ()
End
End Sub

Sub cmdFind_Click ()
    Dim sQuote As String
    Dim src As String
    Dim criteria As String
    Dim currentRecord As String

    sQuote = Chr$(34)

    'Save the current position.
    currentRecord = data1.RecordSet.Bookmark

    src = InputBox$("Enter name of author to find", "Find Box")
    criteria = "[Author] = " & sQuote & src & sQuote
    data1.RecordSet.FindFirst criteria
    If data1.RecordSet.NoMatch Then
        MsgBox "No Record Found!", , "What were you thinking?"
        data1.RecordSet.Bookmark = currentRecord
    End If

End Sub

Sub cmdFirst_Click ()
data1.RecordSet.MoveFirst

End Sub

Sub cmdLast_Click ()
data1.RecordSet.MoveLast
End Sub

Sub cmdLoad_Click ()
   'The following could be set at design time.
    data1.RecordSource = "Select author, title from authors, titles where authors.au_id = titles.au_id"
    data1.Refresh
    txtAuthor.DataField = "author"
    txtTitle.DataField = "title"
    data1.Refresh
End Sub

Sub cmdNext_Click ()
On Error Resume Next
    data1.RecordSet.MoveNext
    If Err Then
        data1.RecordSet.MoveLast
    End If

End Sub

Sub cmdPrev_Click ()
On Error Resume Next
    data1.RecordSet.MovePrevious
    If Err Then
        data1.RecordSet.MoveFirst
    End If

End Sub

