VERSION 2.00
Begin Form BatchXL 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "BatchXL"
   ClientHeight    =   3960
   ClientLeft      =   135
   ClientTop       =   2445
   ClientWidth     =   9285
   Height          =   4365
   Left            =   75
   LinkMode        =   1  'Source
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   ScaleHeight     =   3960
   ScaleWidth      =   9285
   Top             =   2100
   Width           =   9405
   Begin CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   465
      Left            =   7800
      TabIndex        =   8
      Top             =   3330
      Width           =   1215
   End
   Begin CommandButton cmdExcel 
      Caption         =   "&Print"
      Height          =   465
      Left            =   6360
      TabIndex        =   7
      Top             =   3330
      Width           =   1215
   End
   Begin PictureBox picFile 
      AutoSize        =   -1  'True
      Height          =   510
      Left            =   5745
      Picture         =   BATCHXL.FRX:0000
      ScaleHeight     =   480
      ScaleWidth      =   480
      TabIndex        =   18
      TabStop         =   0   'False
      Top             =   3330
      Visible         =   0   'False
      Width           =   510
   End
   Begin PictureBox picNo 
      AutoSize        =   -1  'True
      Height          =   510
      Left            =   5130
      Picture         =   BATCHXL.FRX:0302
      ScaleHeight     =   480
      ScaleWidth      =   480
      TabIndex        =   17
      TabStop         =   0   'False
      Top             =   3330
      Visible         =   0   'False
      Width           =   510
   End
   Begin ComboBox cboFileType 
      Height          =   300
      Left            =   3120
      TabIndex        =   2
      Text            =   "cboFileType"
      Top             =   3360
      Width           =   1815
   End
   Begin DriveListBox drvList 
      Height          =   1530
      Left            =   120
      TabIndex        =   3
      Top             =   3360
      Width           =   2910
   End
   Begin CommandButton cmdClear 
      Caption         =   "C&lear ->"
      Height          =   465
      Left            =   5040
      TabIndex        =   6
      Top             =   1980
      Width           =   1215
   End
   Begin CommandButton cmdRemove 
      Caption         =   "Re&move <-"
      Height          =   465
      Left            =   5040
      TabIndex        =   5
      Top             =   1350
      Width           =   1215
   End
   Begin CommandButton cmdAdd 
      Caption         =   "&Add ->"
      Default         =   -1  'True
      Height          =   465
      Left            =   5040
      TabIndex        =   4
      Top             =   720
      Width           =   1215
   End
   Begin FileListBox filList 
      DragIcon        =   BATCHXL.FRX:0604
      Height          =   2175
      Left            =   3120
      TabIndex        =   0
      Top             =   705
      Width           =   1815
   End
   Begin DirListBox dirList 
      Height          =   2240
      Left            =   120
      TabIndex        =   1
      Top             =   700
      Width           =   2910
   End
   Begin ListBox lstPrint 
      Height          =   2565
      Left            =   6330
      TabIndex        =   9
      TabStop         =   0   'False
      Top             =   360
      Width           =   2790
   End
   Begin Label lblFiletype 
      Caption         =   "List Files of &Type:"
      Height          =   280
      Left            =   3120
      TabIndex        =   15
      Top             =   3000
      Width           =   1815
   End
   Begin Label lblDrives 
      Caption         =   "Dri&ves:"
      Height          =   280
      Left            =   120
      TabIndex        =   14
      Top             =   2980
      Width           =   2910
   End
   Begin Label lblFileName 
      Height          =   260
      Left            =   3120
      TabIndex        =   11
      Top             =   360
      Width           =   1815
   End
   Begin Label lblDirectory 
      Height          =   280
      Left            =   120
      TabIndex        =   13
      Top             =   360
      Width           =   2910
   End
   Begin Label lblPrint 
      Caption         =   "Files to P&rint:"
      Height          =   300
      Left            =   6360
      TabIndex        =   16
      Top             =   40
      Width           =   1455
   End
   Begin Label lblFiles 
      Caption         =   "File &Name:"
      Height          =   300
      Left            =   3120
      TabIndex        =   10
      Top             =   40
      Width           =   1815
   End
   Begin Label lblDir 
      Caption         =   "&Directories:"
      Height          =   300
      Left            =   105
      TabIndex        =   12
      Top             =   40
      Width           =   1185
   End
End
Option Explicit

Dim KeyPressed As Integer

'*****FIX

' DragOver
Const ENTER = 0
Const LEAVE = 1
Const OVER = 2

' MousePointer
Const DEFAULT = 0
Const HOURGLASS = 11

Const NONE = 0
Const AUTOMATIC = 1
Const MANUAL = 2

Const OK = 0
Const YESNO = 4

Const CRITICAL = 16
Const WARNINGQUERY = 32

Const KEYYES = 6
Const KEYNO = 7

Sub cboFileType_Click ()
    'Set the File List pattern
    filList.Pattern = cboFileType.Text
End Sub

Sub cboFileType_LostFocus ()
    Dim I As Integer
    Dim Match As Integer
   
    'Set the File List pattern
    filList.Pattern = cboFileType.Text

    'Extra Credit - Add new pattern to combobox
    Match = False
    For I = 1 To cboFileType.ListCount
	If cboFileType.Text = cboFileType.List(I - 1) Then
	    Match = True
	End If
    Next I

    If Match = False Then
	'Add the new pattern to the list
	cboFileType.AddItem cboFileType.Text
    End If

End Sub

Sub cmdAdd_Click ()
    Dim Path As String
    
    Path = GetPath()
    
    'Test for filename selected
    If filList.ListIndex <> -1 Then
	lstPrint.AddItem Path + filList.FileName
    End If
End Sub

Sub cmdCancel_Click ()
    End
End Sub

Sub cmdClear_Click ()
    lstPrint.Clear
End Sub

Sub cmdExcel_Click ()
    Dim lcv As Integer
    Dim rc As Integer
  
    'Check to see if "Files to Print" list is empty
    If lstPrint.ListCount = 0 Then
	MsgBox "The Print List is empty", OK + CRITICAL, "Empty Print List"
	Exit Sub
    End If

    'Set up the link to Excel. First clear the linkmode
    '*****FIX
    'Set the LinkTopic to Excel
    '*****FIX
    'Establish the Manual (Cold) link
    '*****FIX
    
    'Check to see if the printer is ready.
    KeyPressed = MsgBox("Is Your Printer Ready??", YESNO + WARNINGQUERY, "Excel Batch Print Utility")

    'If the user decided NO get outta here.
    If KeyPressed = KEYNO Then
	Exit Sub
    End If
    
    'Change Mouse pointer for the duration of the printing process.
    '*****FIX
    
    'Print the list of files (OPEN,PRINT,CLOSE)

    For lcv = 0 To lstPrint.ListCount - 1
	lstPrint.ListIndex = lcv
	
	'Build the Excel OPEN command
	'*****FIX
	'Set the LinkTimeout value
	'*****FIX
	'Send the command to Excel
	'*****FIX
	'Yield to Excel
	'*****FIX
	
	
	'Build the Excel PRINT command
	'*****FIX
	'Set the LinkTimeout value
	'*****FIX
	'Send the command to Excel
	'*****FIX
	'Yield to Excel
	'*****FIX
	
	
	'Build the Excel CLOSE command
	'*****FIX
	'Set the LinkTimeout value
	'*****FIX
	'Send the command to Excel
	'*****FIX
	'Yield to Excel
	'*****FIX
    
    Next lcv
    
    'Terminate the Excel DDE link
    '*****FIX
    
    'Now that printing is done, restore mouse pointer to its default.
    '*****FIX
   
    'Signal all files are printed
    '*****FIX
   
End Sub

Sub cmdRemove_Click ()
   
   ' Test to see if item is selected
   If lstPrint.ListIndex <> -1 Then
      ' Remove Selected Item from the list
      lstPrint.RemoveItem lstPrint.ListIndex
   End If

End Sub

Sub dirList_Change ()

   ' Change machine's current working directory
   ChDir (dirList.Path)

   ' Update File list since directory has changed
   filList.Path = dirList.Path

   ' Update the directory label
   lblDirectory.Caption = dirList.Path

End Sub

Sub drvList_Change ()

   ' Change machine's current working drive
   ChDrive (drvList.Drive)

   ' Update directory list since drive has changed
   dirList.Path = drvList.Drive

End Sub

Sub filList_Click ()
    'Fill in Filename label
    lblFileName.Caption = filList.FileName
End Sub

Sub filList_DblClick ()
    Dim Path As String

    Path = GetPath()
    
    lstPrint.AddItem Path + filList.FileName
End Sub

Sub filList_DragOver (Source As Control, X As Single, Y As Single, State As Integer)

    'Control which icon to display
    Select Case State
	Case ENTER
	    filList.DragIcon = picFile.Picture
	Case LEAVE
	    filList.DragIcon = picNo.Picture
    End Select

End Sub

Sub filList_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)
    'Drag the selected files
    filList.Drag
End Sub

Sub filList_PathChange ()
    'Check to see if any filList entry is highlighted
    If filList.ListIndex >= 0 Then
	lblFileName.Caption = filList.FileName
    Else
	lblFileName.Caption = ""
    End If

End Sub

Sub filList_PatternChange ()
    'Check to see if any filList entry is highlighted
    If filList.ListIndex >= 0 Then
	lblFileName.Caption = filList.FileName
    Else
	lblFileName.Caption = ""
    End If
End Sub

Sub Form_Load ()
    'Build Combo Box entries
    cboFileType.AddItem "*.*"
    cboFileType.AddItem "*.XLS"
    cboFileType.AddItem "*.XLM"
    cboFileType.AddItem "*.XLC"

    'Establish the default entry for the combo box.
    cboFileType.Text = "*.*"

    'Set Directory Label to active directory
    lblDirectory.Caption = LCase$(CurDir$)
End Sub

Sub Form_Unload (CANCEL As Integer)
    End
End Sub

Function GetPath () As String
    If Right$(dirList.Path, 1) = "\" Then
	GetPath = filList.Path
    Else
	GetPath = filList.Path + "\"
    End If
End Function

Sub lstPrint_DragDrop (Source As Control, X As Single, Y As Single)
    Dim Path As String

    Path = GetPath()
   
    lstPrint.AddItem Path + filList.FileName
End Sub

Sub lstPrint_DragOver (Source As Control, X As Single, Y As Single, State As Integer)
    'Control which icon to display
    Select Case State
	Case ENTER
	    filList.DragIcon = picFile.Picture
	Case LEAVE
	    filList.DragIcon = picNo.Picture
    End Select
End Sub

