Option Explicit

Global Const FormTitle = "Editor #"

Const MAX_SIZE = 3

'***FIX #1 declare an array of form references


'***FIX #2 declare a user-defined type


'***FIX #3 declare an array of user-defined types from previous fix



'This variable points to the empty spot in the Editors() array.
Global CurrentEditor As Integer

'This variable tracks the current size of the array Editor()
'and the array EditorData().
Dim EditorCount As Integer


'Arrange Method for MDI Forms
Global Const CASCADE = 0
Global Const TILE_HORIZONTAL = 1
Global Const TILE_VERTICAL = 2
Global Const ARRANGE_ICONS = 3

'WindowState
Global Const NORMAL = 0
Global Const MINIMIZED = 1
Global Const MAXIMIZED = 2

'Clipboard
Global Const CF_TEXT = 1

'MsgBox parameters
Global Const MB_OK = 0
Global Const MB_OKCANCEL = 1
Global Const MB_ABORTRETRYIGNORE = 2
Global Const MB_YESNOCANCEL = 3
Global Const MB_YESNO = 4
Global Const MB_RETRYCANCEL = 5

Global Const MB_ICONSTOP = 16
Global Const MB_ICONQUESTION = 32
Global Const MB_ICONEXCLAMATION = 48
Global Const MB_ICONINFORMATION = 64

Global Const MB_APPLMODAL = 0
Global Const MB_DEFBUTTON1 = 0
Global Const MB_DEFBUTTON2 = 256
Global Const MB_DEFBUTTON3 = 512
Global Const MB_SYSTEMMODAL = 4096

'MsgBox return values
Global Const IDOK = 1
Global Const IDCANCEL = 2
Global Const IDABORT = 3
Global Const IDRETRY = 4
Global Const IDIGNORE = 5
Global Const IDYES = 6
Global Const IDNO = 7

Sub CreateNewEditor (sfilename As String)
    Dim fhandle As Integer

    'For the very first Editor child, it's necessary to size the 2 arrays.
    'No new child is needed: used the one obtained at design time.
    If CurrentEditor = 0 Then
	CurrentEditor = 1
	EditorCount = MAX_SIZE
	ReDim Editors(EditorCount)
	ReDim EditorData(EditorCount)
	
	'***FIX Make Editors(1) 'point' to the object frmMDIChild


    Else
	'In all other cases, create a new instance of an Editor child.
	
	'***FIX Create a new instance of the class frmMDIChild
	'and call it newEditor
	
	
	'Next, determine if the arrays need to be expanded.
	If CurrentEditor > EditorCount Then
	    EditorCount = EditorCount + MAX_SIZE
	    ReDim Preserve Editors(EditorCount)
	    ReDim Preserve EditorData(EditorCount)
	End If
	'Finally, 'point' to the newest Editor.
	
	
	'***FIX Make Editors(CurrentEditor) 'point' to the new object
    

    End If

    'If the incoming argument is not empty, open the file
    'and load it into the current child's text box.
    If sfilename <> "" Then
	fhandle = FreeFile
	Open sfilename For Input As fhandle
	Editors(CurrentEditor).txtEditBox.Text = Input$(LOF(fhandle), fhandle)
	'Build the title without a path.
	Editors(CurrentEditor).Caption = FormTitle + Str$(CurrentEditor) + " (" + sfilename + ")"
	Close fhandle
    Else
	Editors(CurrentEditor).Caption = FormTitle & CurrentEditor
    End If
	
    'Set the 2 variables in the array.
    EditorData(CurrentEditor).Filename = sfilename
    EditorData(CurrentEditor).dirtyflag = False

    '***FIX Capture the integer CurrentEditor into this object's tag.
    
    
    Editors(CurrentEditor).Show
    
    'Finally, bump the counter for the next child.
    CurrentEditor = CurrentEditor + 1
End Sub

Function GetFileName () As String
    'Set up the common dialog box.
    frmMDIParent.CMDialog1.Filter = "Text Files (*.txt)|*.txt|All files (*.*)|*.*"
    frmMDIParent.CMDialog1.Filename = ""

    'Invoke the Dialog Box...
    frmMDIParent.CMDialog1.Action = 1

    'and return the filename.
    GetFileName = frmMDIParent.CMDialog1.Filename
End Function

