VERSION 2.00
Begin Form frmMDIChild 
   Caption         =   "Child"
   ClientHeight    =   1230
   ClientLeft      =   780
   ClientTop       =   1605
   ClientWidth     =   3645
   Height          =   1920
   Left            =   720
   LinkTopic       =   "Form1"
   ScaleHeight     =   1230
   ScaleWidth      =   3645
   Top             =   975
   Width           =   3765
   Begin TextBox txtEditBox 
      Height          =   975
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   2415
   End
   Begin Menu mnuFile 
      Caption         =   "&File"
      Begin Menu mnuFileNew 
         Caption         =   "&New Child"
      End
      Begin Menu mnuFileOpen 
         Caption         =   "&Open File..."
      End
      Begin Menu mnuFileClose 
         Caption         =   "&Close Window"
      End
      Begin Menu mnuFileSep1 
         Caption         =   "-"
      End
      Begin Menu mnuFileSave 
         Caption         =   "&Save File"
      End
      Begin Menu mnuFileSep2 
         Caption         =   "-"
      End
      Begin Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin Menu mnuEdit 
      Caption         =   "&Edit"
      Begin Menu mnuEditCutSys 
         Caption         =   "Cut to System Buffer"
         Shortcut        =   ^X
      End
      Begin Menu mnuEditCopySys 
         Caption         =   "Copy to System Buffer"
         Shortcut        =   ^C
      End
      Begin Menu mnuEditPasteSys 
         Caption         =   "Paste from System Buffer"
         Shortcut        =   ^V
      End
   End
   Begin Menu mnuWindows 
      Caption         =   "&Windows"
      Begin Menu mnuWindowsMinimize 
         Caption         =   "&Minimize All Windows"
      End
      Begin Menu mnuWindowsRestore 
         Caption         =   "&Restore All Windows"
      End
      Begin Menu mnuSep4 
         Caption         =   "-"
      End
      Begin Menu mnuWindowsCascade 
         Caption         =   "&Cascade"
      End
      Begin Menu mnuWindowsTile 
         Caption         =   "&Tile"
      End
      Begin Menu mnuWindowsArrange 
         Caption         =   "&Arrange Icons"
      End
      Begin Menu mnuSep3 
         Caption         =   "-"
      End
   End
End
Option Explicit

'These constants are used for sizing controls and this form.
Const ICON_HEIGHT = 1000
Const BORDER_SCROLL_WIDTH = 340

Const NO_QUERY = False
Const DO_QUERY = True

Sub CloseCurrentEditor (index As Integer)
    '***FIX There are 4 things to do
    'In all cases, the incoming argument provides the subscript.
    '1) unload the current object. Use the reference from
    '   the array  Editors() to do this.
    '2) set that reference to Nothing
    '3) set the dirtyflag for this editor to false
    '4) set the filename for this editor to ""


End Sub

Sub Form_Resize ()
    'These statements will keep the text box and paste
    'buffers in proportion to the size of the form.
    txtEditBox.Width = Me.ScaleWidth
    txtEditBox.Height = Me.ScaleHeight
End Sub

Sub Form_Unload (Cancel As Integer)
    'Pass TRUE to cause the subroutine to query the user.
    '**** FIX

    CloseCurrentEditor Val(Me.Tag)
End Sub

Sub mnuEdit_Click ()
    'Only enable pasting if there's text in the clipboard.
    mnueditpastesys.Enabled = Clipboard.GetFormat(CF_TEXT)
    
    'If something is highlighted then set system
    'cut/copy options to reflect highlighting status.
    If txtEditBox.SelLength = 0 Then
	mnueditcutsys.Enabled = False
	mnueditcopysys.Enabled = False
    Else
	mnueditcutsys.Enabled = True
	mnueditcopysys.Enabled = True
    End If
    
End Sub

Sub mnuEditCopySys_Click ()
    Clipboard.SetText txtEditBox.SelText
End Sub

Sub mnuEditCutSys_Click ()
    Clipboard.SetText txtEditBox.SelText
    txtEditBox.SelText = ""
End Sub

Sub mnuEditPasteSys_Click ()
     txtEditBox.SelText = Clipboard.GetText()
End Sub

Sub mnuFileClose_Click ()
    '***FIX Unload this instance of an Editor
End Sub

Sub mnuFileExit_Click ()
    'If the user clicks on this, then the entire process, including all
    'MDI children, must be shut down. Unloading the MDI parent will
    'automatically trigger a call to each child's Unload event,
    'where the appropriate action is taken.
    
    '***FIX unload the parent
End Sub

Sub mnuFileNew_Click ()
    '***FIX call a subroutine and pass it an empty string
End Sub

Sub mnuFileOpen_Click ()
    '*** FIX
    'Obtain a filename, call a subroutine, and pass it the filename.
    'The code here is the same as that of the parent.
End Sub

Sub mnuFileSave_Click ()
    '***FIX call a subroutine to save the current file
    'That subroutine WON'T have to prompt the user.

End Sub

Sub mnuWindowsArrange_Click ()
   frmMDIParent.Arrange ARRANGE_ICONS
End Sub

Sub mnuWindowsCascade_Click ()
   frmMDIParent.Arrange CASCADE
End Sub

Sub mnuWindowsMinimize_Click ()
    Dim i As Integer
    
    '***FIX Write a loop to iterate through the forms
    'collection and minimize all objects of the frmMDIChild class
    

End Sub

Sub mnuWindowsRestore_Click ()
    Dim i As Integer
    'Iterate through all the forms.  If a form is an MDIChild, set its
    'WindowState to normal
    For i = 0 To forms.Count - 1
	If TypeOf forms(i) Is frmMDIChild Then
	    If forms(i).WindowState <> NORMAL Then
		forms(i).WindowState = NORMAL
	    End If
	End If
    Next i

End Sub

Sub mnuWindowsTile_Click ()
   frmMDIParent.Arrange TILE_HORIZONTAL
End Sub

Sub SaveCurrentEditor (query As Integer)
    Dim fhandle As Integer
    Dim i As Integer, rc As Integer
    Dim fname As String

    i = Val(Me.Tag)

    'There's nothing to do if the dirty flag isn't set!
    If EditorData(i).dirtyflag = False Then
	Exit Sub
    End If

    'Only query if the incoming argument requires it.
    If (query = True) Then
	
	'Build an appropriate string for the message box.
	If EditorData(i).filename = "" Then
	    fname = "Buffer"
	Else
	    fname = EditorData(i).filename
	End If
	
	'Determine what the user wants to do.
	rc = MsgBox(fname + " has changed. Save before terminating?", MB_YESNO)
	If rc = IDNO Then
	    Exit Sub
	End If
    End If
    
    'If the user just opened a new window text without opening a file, then
    'there's no file name, so one must be obtained.
    If EditorData(i).filename = "" Then
	EditorData(i).filename = InputBox$("Enter a file name. File will be saved in " + CurDir$, "No file name available!")
	Me.Caption = FormTitle & Me.Tag + " (" + EditorData(i).filename + ")"
    End If
    
    'Now if the filename is still empty, then just end this subroutine.
    If EditorData(i).filename = "" Then
	Exit Sub
    End If

    'Get a fresh handle and write the file to it.
    fhandle = FreeFile
    Open EditorData(i).filename For Output As fhandle
    Print #fhandle, txtEditBox.Text
    Close fhandle
    EditorData(i).dirtyflag = False
End Sub

Sub txtEditBox_Change ()
    Dim i As Integer
    
    '***FIX This object's dirtyflag must be set to true
    'capture the object's tag into i and use this as
    'a subscript into the EditorData() array.

End Sub

