VERSION 2.00
Begin Form frmInput 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "GetInput"
   ClientHeight    =   3210
   ClientLeft      =   1230
   ClientTop       =   1755
   ClientWidth     =   7455
   Height          =   3900
   KeyPreview      =   -1  'True
   Left            =   1170
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3210
   ScaleWidth      =   7455
   Top             =   1125
   Width           =   7575
   Begin CommandButton cmdReset 
      Caption         =   "Reset"
      Height          =   495
      Left            =   5280
      TabIndex        =   9
      Top             =   1920
      Width           =   1215
   End
   Begin CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   495
      Left            =   5280
      TabIndex        =   8
      Top             =   1080
      Width           =   1215
   End
   Begin CommandButton cmdOK 
      Caption         =   "OK"
      Enabled         =   0   'False
      Height          =   495
      Left            =   5280
      TabIndex        =   7
      Top             =   240
      Width           =   1215
   End
   Begin MaskEdBox mskYears 
      Format          =   "0"
      Height          =   375
      Left            =   1320
      PromptChar      =   "_"
      TabIndex        =   5
      Top             =   1680
      Width           =   375
   End
   Begin MaskEdBox mskSSN 
      Height          =   380
      Left            =   1320
      PromptChar      =   "_"
      TabIndex        =   4
      Top             =   960
      Width           =   1455
   End
   Begin MaskEdBox mskName 
      Height          =   375
      Left            =   1320
      PromptChar      =   "_"
      TabIndex        =   3
      Top             =   240
      Width           =   2655
   End
   Begin Label lblError 
      Alignment       =   2  'Center
      BackColor       =   &H00C0C0C0&
      BorderStyle     =   1  'Fixed Single
      Height          =   735
      Left            =   2040
      TabIndex        =   6
      Top             =   2040
      Visible         =   0   'False
      Width           =   2055
      WordWrap        =   -1  'True
   End
   Begin Label lblYears 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Years Employed (0-50)"
      Height          =   615
      Left            =   240
      TabIndex        =   2
      Top             =   1560
      Width           =   855
   End
   Begin Label lblSSN 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Social Security No."
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   1095
   End
   Begin Label lblName 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Name"
      Height          =   255
      Left            =   720
      TabIndex        =   0
      Top             =   240
      Width           =   495
   End
   Begin Menu mnuFile 
      Caption         =   "&File"
      Begin Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin Menu mnuHelp 
      Caption         =   "&Help"
      Begin Menu mnuHelpAbout 
         Caption         =   "&About..."
      End
   End
End
Const BACKSPACE = 8
Const CARRIAGE_RETURN = 13
Const MSK_COUNT = 3

Dim lcv As Integer

Dim crlf As String

Dim ErrorMessage As String

'ValidDataFlags is used in the global routine ValidateOKButton() to
'determine if the the current Masked Edit Control has
'correct data, and it's used in cmdOK() to set the focus
'to the offending masked edit control.

'*****FIX

'The integers of EnableOKFlags's are used as flags to
'decide when to enable the OK button.

'*****FIX

Sub cmdCancel_Click ()
    End
End Sub

Sub cmdOK_Click ()
    Dim ErrorIndex As Integer
    
    'Find the first invalid flag
    '*****FIX

    Select Case ErrorIndex
        Case 0
            ErrorMessage = crlf + "You must" + crlf + "provide a name." + crlf
            'Set the focus to the appropriate control
            '*****FIX
        Case 1
            ErrorMessage = crlf + "You must provide" + crlf + "a 9 digit SSN." + crlf
            'Set the focus to the appropriate control
            '*****FIX
        Case 2
            ErrorMessage = crlf + "You must provide a" + crlf + "number between 0 and 50." + crlf
            'Set the focus to the appropriate control
            '*****FIX
        Case MSK_COUNT
            Beep
            MsgBox "They're all good!"
            Exit Sub
    End Select
    
    DisplayErrorLabel ErrorMessage
End Sub

Sub cmdReset_Click ()
    'If you want to clear a masked edit control, assign
    'strings to the control as follows.
    mskName.Text = "_________________________"
    mskYears.Text = "__"
    mskSSN.Text = "___-__-____"
    
    lblError.Visible = False
    
    cmdOk.Enabled = False
    mskName.SetFocus
    For lcv = 0 To MAX_COUNT - 1
        EnableOKFlags(lcv) = False
        ValidDataFlags(lcv) = False
    Next lcv
End Sub

Sub DetermineInputValidity (CurrentControl As Control)
    'This subroutine is called after every change event
    'to determine the validity of the contents of the
    'current control. The array ValidDataFlags() is examined
    'in cmdOK to determine which Masked Edit control is
    'invalid.
    
    'The Text property of Masked Edit controls contains
    'masking characters. TextWOMask will be used with
    'ClipText to examine just the text portion of the control.
    Dim TextWOMask As String
    Dim YearsWorked As Integer
    Dim index

    index = Val(CurrentControl.Tag)
    TextWOMask = CurrentControl.ClipText

    'Each control's tag corresponds to its index into the
    'array ValidDataFlags.
    Select Case index
        Case 0                  'Name
            If TextWOMask <> "" Then
                ValidDataFlags(0) = True
            Else
                ValidDataFlags(0) = False
            End If
        
        Case 1                      'SSN
            'Determine if what is in mskSSN is any good, i.e. its length is 9.
            '*****FIX
        
        Case 2                      'Years worked
            If TextWOMask = "" Then
                ValidDataFlags(2) = False
            Else
                'Determine if what is in mskYears is any good.
                YearsWorked = Val(TextWOMask)
                '*****FIX
            End If
    End Select
End Sub

Sub DisplayErrorLabel (msg As String)
    lblError.Height = TextHeight(msg)
    lblError.Width = TextWidth(msg) + 500
    lblError.Caption = msg
    lblError.Visible = True
End Sub

Sub Form_KeyPress (keyascii As Integer)
    'The idea here is to make the Enter key behave the same as the Tab.
    'However, for this program Enter will only cycle through the
    'Masked Edit Boxes.
    
    If keyascii = CARRIAGE_RETURN Then
        Select Case Screen.ActiveControl.TabIndex
            Case 1
                '*****FIX
            Case 3
                '*****FIX
            Case 5
                '*****FIX
            Case Else
                Exit Sub
        End Select
        
        'Consume the keystroke.
        '*****FIX
    End If
End Sub

Sub Form_Load ()
    'Establish a value in crlf for use in various events.
    crlf = Chr$(13) + Chr$(10)
End Sub

Sub lblError_Click ()
    lblError.Visible = False
End Sub

Sub mnuFileExit_Click ()
    'Terminate the application.
    End
End Sub

Sub mnuHelpAbout_Click ()

   ' Hide the main form
   frmInput.Hide

   ' Display Help form
   frmHelp.Show

End Sub

Sub mskName_Change ()
    'Call the routine to determine if it's
    'OK to enable the OK button.
    '*****FIX
End Sub

Sub mskName_KeyPress (keyascii As Integer)
    'If the key's a backspace hide the error message.
    'It doesn't hurt to hide it if it's already hidden
    '*****FIX

End Sub

Sub mskName_LostFocus ()
    'Call the subroutine that determines if the
    'current control has valid contents.
    '*****FIX
    
    'Since we're leaving the control turn off the error message.
    '*****Fix
End Sub

Sub mskName_ValidationError (InvalidText As String, startposition As Integer)
    'If error occurs because the user types in too many
    'characters, the StartPosition will be equal to MaxLength.
    'Display an error message

End Sub

Sub mskSSN_Change ()
    'Call the routine to determine if it's
    'OK to enable the OK button.
    '*****FIX
End Sub

Sub mskSSN_KeyPress (keyascii As Integer)
    'If an error is displayed, but this character is a
    'a backspace OR a digit, then turn off the error.
    '*****FIX
End Sub

Sub mskSSN_LostFocus ()
    'Call the subroutine that determines if the
    'current control has valid contents.
    '*****FIX

    'Since we're leaving the control turn off the error message.
    '*****FIX
End Sub

Sub mskSSN_ValidationError (InvalidText As String, startposition As Integer)
    ErrorMessage = crlf + "Social Security # must" + crlf + "be filled with 9 digits only!" + crlf
    
    'Now, display the error message.
    '*****FIX
End Sub

Sub mskYears_Change ()
    'Call the routine to determine if it's
    'OK to enable the OK button.
    '*****FIX
End Sub

Sub mskYears_KeyPress (keyascii As Integer)
    'If this character is a backspace OR a digit and
    'an error is displayed, then turn off the error.
    If keyascii = BACKSPACE Or (keyascii > 47 And keyascii < 58) Then
        lblError.Visible = False
    End If
End Sub

Sub mskYears_LostFocus ()
    'Call the subroutine that determines if the
    'current control has valid contents.
    '*****FIX
    
    lblError.Visible = False
End Sub

Sub mskYears_ValidationError (InvalidText As String, startposition As Integer)
    If startposition = mskYears.MaxLength Then
        ErrorMessage = crlf + "Limited to 2 digits!" + crlf
    Else
        ErrorMessage = crlf + "Digits only" + crlf
    End If
    DisplayErrorLabel ErrorMessage
End Sub

Sub ValidateOKButton (CurrentControl As Control)
    Dim index

    'The Text property of Masked Edit controls contains
    'masking characters. TextWOMask will be used with
    'ClipText to examine just the text portion of the control.
    Dim TextWOMask As String
    
    '*****fix #1

    'For the purposes of this program, all that needs
    'to be done to enable the OK button is for each
    'Masked Edit Control to have non-empty contents.
    
    'Each control's tag will be an index into the
    'array EnableOKFlags. Tag is a string, so convert it.
    '*****fix #2

    'Set the appropriate flag to true of false, depending
    'on whether TextWOMask is empty or not.
    '*****fix #3
    
    'If any of the flags are false disable the OK button
    'and exit this subroutine. Otherwise, enable the
    'OK button.
    '*****fix #4

End Sub

